c====================================================================
c
c		ggdelta
c
c====================================================================


c=========================================================================	

      double precision function gg_me(whichpart,z,lambda,QQQ,wlo)
      implicit none
      character*5 whichpart
      
      double precision QQQ,gg_LO_exact,gg_n0
      double precision gg_n1,gg_n2
      double precision z,gg_NLO_exact,lambda
      integer wlo
      double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
      double precision WC2NNLO
      common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
      !: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
      integer effective_theory_flag
      common /common_eff_theory_flag/ effective_theory_flag
c -------
      if (effective_theory_flag.eq.0) then 
         select case (wlo)
         case(0)
            gg_me = gg_LO_exact(whichpart,z,QQQ) 
     #+ WC0LO * gg_n0(whichpart,z)
         case(1)
            gg_me = gg_NLO_exact(whichpart,z,lambda,QQQ)
     #+ WC1NLO * gg_n0(whichpart,z) 
     #+ WC0NLO * gg_n1(whichpart,z) 
         case(2)
            gg_me = WC2NNLO * gg_n0(whichpart,z) 
     #+ WC1NNLO * gg_n1(whichpart,z)
     #+ WC0NNLO * gg_n2(whichpart,z)
         end select
      elseif (effective_theory_flag.eq.1) then
         select case (wlo)
         case(0)
            gg_me =   WC0LO * gg_n0(whichpart,z)
            
         case(1)
            gg_me =  WC1NLO * gg_n0(whichpart,z) 
     #+ WC0NLO * gg_n1(whichpart,z) 
         case(2)
            gg_me = WC2NNLO * gg_n0(whichpart,z) 
     #+ WC1NNLO * gg_n1(whichpart,z)
     #+ WC0NNLO * gg_n2(whichpart,z)
         end select
      endif
      end


      double precision function gg_LO_exact(whichpart,z,QQQ)
      implicit none
      character*5 whichpart
      double precision z,QQQ,ggdelta_LO_exact
      if (whichpart.eq.'delt') then 
         gg_LO_exact=ggdelta_LO_exact(QQQ)
      elseif (whichpart.eq.'plus') then 
         gg_LO_exact=0d0
      elseif (whichpart.eq.'regu') then 
         gg_LO_exact=0d0
      endif
     
     
      end

      double precision function gg_NLO_exact(whichpart,z,lambda,QQQ)
      implicit none
      character*5 whichpart
      double precision z,lambda,QQQ,ggdelta_NLO_exact,gg_n1
      double precision ggreg_exact_NLO
      double complex sborn_mass
      if (whichpart.eq.'delt') then 
          gg_NLO_exact=ggdelta_NLO_exact(QQQ)
      elseif (whichpart.eq.'plus') then 
          gg_NLO_exact=gg_n1(whichpart,z)* abs(sborn_mass(QQQ))**2 ! NLO exact
      elseif (whichpart.eq.'regu') then 
          gg_NLO_exact=ggreg_exact_NLO(z,lambda,QQQ)
      endif


      end

c=========================================================================	
      double precision function ggdelta_LO_exact(QQQ)
      implicit none 
      double precision QQQ
      double complex sborn_mass	
      ggdelta_LO_exact = abs(sborn_mass(QQQ))**2
      end
c=========================================================================	
	double precision function ggdelta_NLO_exact(QQQ)
	implicit none 
	double precision QQQ
	double complex sborn_mass,sum_q_born,sum_q_virtual_star
	double complex svirtual_mass	
	double precision L, Lt, Lr, NF, pi, z2, z3
        common /xsection/ L, Lt, Lr, NF 
        common /consts/ pi, z2, z3
	double precision b0,z4
	!note: beta_0 below HARDCODED with nf=5
	b0=23d0/12d0  
	z4=1.082323234d0
	sum_q_born =  sborn_mass(QQQ)
	sum_q_virtual_star = CONJG(svirtual_mass(QQQ))
c			Lr=log(mur**2/mhiggs**2)   L=log(muf**2/mhiggs**2)
	ggdelta_NLO_exact = abs(sum_q_born)**2  * (2d0*b0*(Lr-L) + pi**2)
     #     +	dreal(sum_q_born*sum_q_virtual_star)   
c      print*,"ratio ",ggdelta_NLO_exact/ ( abs(sum_q_born)**2  * 
c     #		(2d0*b0*(Lr-L) + pi**2)
c     #     +	abs(sum_q_born)**2  *11d0/2d0)     
c     #		+  abs(sum_q_born)**2  *11d0/2d0 
	!print*,sum_q_born,sum_q_virtual_star
	end

c=========================================================================	

      double precision function gg_n0(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO

      gg_n0=EggLO(whichpart,z)
      end

c=========================================================================	

      double precision function gg_n1(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO,EggNLO
      double precision B0
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF

      B0 = 11d0/4d0 - 1d0/6d0 * NF

      gg_n1=(-2d0*B0*L+2d0*B0*Lr)*EggLO(whichpart,z)
     $         +EggNLO(whichpart,z)
      end
c=========================================================================	

      double precision function gg_n2(whichpart,z)
      implicit none
      character*4 whichpart
      double precision res,z,EggLO,EggNLO,EggNNLO
      double precision B0,B1
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      
      B0 = 11d0/4d0 - 1d0/6d0 * NF
      B1 = 51d0/8d0 - 19d0/24d0 * NF


      gg_n2=(3d0*B0**2*Lr**2+3d0*B0**2*L**2+4d0*B1*Lr
     $    +(-6d0*B0**2*Lr-4d0*B1)*L)*EggLO(whichpart,z)
     $    +(3d0*B0*Lr-3d0*B0*L)*EggNLO(whichpart,z)
     $    +EggNNLO(whichpart,z)

      
      end

c=========================================================================	

      double precision function EggLO(whichpart,x)
      implicit none
      character*4 whichpart
      double precision res,x

      if (whichpart.eq.'delt') then 
          EggLO=1d0
      elseif (whichpart.eq.'plus') then 
          EggLO=0d0
      elseif (whichpart.eq.'regu') then 
          EggLO=0d0
	 endif
      !print*,"\nEggLO=",EggLO," : ",whichpart
      end
c=========================================================================	

      double precision function EggNLO(whichpart,x)
      implicit none
      character*4 whichpart
      double precision res,x
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      double precision LLz,DD0,DD1,DD2,DD3
      double precision pi,z2,z3
      common /consts/ pi, z2, z3      

      LLz = dlog(1d0-x)
      DD0=1d0
      DD1=LLz
      DD2=LLz**2
      DD3=LLz**3

      if (whichpart.eq.'delt') then 
          res=6d0*z2
      elseif (whichpart.eq.'plus') then 
          res= -6d0*L*DD0+12*DD1
      elseif (whichpart.eq.'regu') then 
          res=(6d0*(x**3-x**2+2d0*x-1d0))*L/x
     $         +6d0*(x**2-x+1d0)**2*dlog(x)/((x-1d0)*x)
     $         +(11d0/2d0)*(x-1d0)**3/x
     $         -(12d0*(x**3-x**2+2d0*x-1d0))*dlog(1d0-x)/x
      endif
      EggNLO=res
      end

c=========================================================================	

      double precision function EggNNLO(whichpart,x)
c      implicit none
      implicit double precision (t)
      character*4 whichpart
      double precision res,x
      double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF
      double precision LLz,DD0,DD1,DD2,DD3
      double precision pi,z2,z3
      common /consts/ pi, z2, z3  
      double precision z4
      double precision Li2,Li3,S12

      z4=1.082323234d0
      LLz = dlog(1d0-x)
      DD0=1d0
      DD1=LLz
      DD2=LLz**2
      DD3=LLz**3

      if (whichpart.eq.'delt') then 
      EggNNLO= 0.33D2 / 0.2D1 * L * z2 
     $ - 0.171D3 / 0.2D1 * L * z3 + 0.27D2 /
     # 0.2D1 * L - 0.18D2 * z2 * L ** 2 + 0.1071D4 / 0.8D1 * z4 - 0.54D2
     # * z2 ** 2 + 0.67D2 / 0.2D1 * z2 - 0.165D3 / 0.4D1 * z3 + 0.837D3 
     #/ 0.16D2 + (-L * z2 - 0.11D2 / 0.6D1 * L - 0.5D1 / 0.3D1 * z2 + 0.
     #5D1 / 0.6D1 * z3 - 0.247D3 / 0.36D2) * NF

      elseif (whichpart.eq.'plus') then 
      EggNNLO=(DD0 * L ** 2 / 0.2D1 + 0.5D1 / 0.3D1 * DD0 * L 
     $ - 0.2D1 * DD0
     # * z2 + 0.14D2 / 0.9D1 * DD0 - 0.2D1 * DD1 * L - 0.10D2 / 0.3D1 * 
     #DD1 + dble(2 * DD2)) * NF + 0.351D3 / 0.2D1 * DD0 * z3 + 0.33D2 * 
     #DD0 * z2 - 0.101D3 / 0.3D1 * DD0 + 0.45D2 * DD0 * L * z2 - 0.67D2 
     #/ 0.2D1 * DD0 * L - 0.33D2 / 0.4D1 * DD0 * L ** 2 - 0.90D2 * DD1 *
     # z2 + 0.67D2 * DD1 + 0.33D2 * DD1 * L + 0.36D2 * DD1 * L ** 2 - db
     #le(33 * DD2) - 0.108D3 * dble(DD2) * L + dble(72 * DD3)

      elseif (whichpart.eq.'regu') then 
      t1 = dlog(x)
      t2 = L * t1
      t3 = 0.1D1 - x
      t4 = dlog(t3)
      t5 = x ** 2
      t6 = t5 ** 2
      t7 = t4 * t6
      t10 = t6 * x
      t11 = t4 * t10
      t14 = t5 * x
      t15 = t4 * t14
      t18 = t4 * t5
      t21 = t4 * x
      t24 = x + 0.1D1
      t25 = dlog(t24)
      t42 = z2 * t1
      t47 = t42 * x
      t49 = 0.18321D5 + 0.6048D4 * t7 * t2 - 0.6048D4 * t2 * t11 - 0.604
     #8D4 * t2 * t15 - 0.6048D4 * t2 * t18 + 0.6048D4 * t2 * t21 - 0.864
     #D3 * t2 * t25 * t10 - 0.864D3 * t2 * t25 * t6 - 0.864D3 * t2 * t25
     # * t14 + 0.864D3 * t2 * t25 * t5 + 0.864D3 * t2 * t25 * x - 0.1852
     #3D5 * x + 0.8208D4 * t42 * t6 - 0.4320D4 * t42 * t10 - 0.2592D4 * 
     #t47
      t50 = t1 * t4
      t51 = t50 * t14
      t53 = t50 * t5
      t55 = t50 * x
      t57 = t1 * t25
      t68 = L ** 2
      t69 = t68 * t1
      t71 = 0.864D3 * t69 * t14
      t73 = 0.864D3 * t69 * x
      t74 = t2 * t6
      t76 = t2 * t14
      t78 = t2 * t5
      t80 = t2 * x
      t82 = L * t4
      t83 = t82 * t6
      t85 = t82 * t14
      t87 = -0.1692D4 * t51 + 0.396D3 * t53 + 0.21492D5 * t55 + 0.792D3 
     #* t57 * t10 + 0.1512D4 * t57 * t6 - 0.1656D4 * t57 * t14 - 0.2520D
     #4 * t57 * t5 + 0.864D3 * t57 * x - t71 + t73 - 0.11952D5 * t74 - 0
     #.5328D4 * t76 + 0.7200D4 * t78 - 0.7344D4 * t80 + 0.16704D5 * t83 
     #- 0.2448D4 * t85
      t89 = t82 * t5
      t91 = t82 * x
      t93 = Li2(x)
      t94 = L * t93
      t95 = t94 * t14
      t97 = t94 * x
      t99 = t1 ** 2
      t100 = L * t99
      t101 = t100 * t14
      t103 = t100 * x
      t105 = t1 * t93
      t106 = t105 * t14
      t108 = t105 * t5
      t110 = t105 * x
      t112 = t4 * t93
      t113 = t112 * t14
      t115 = t112 * t5
      t117 = t112 * x
      t119 = t99 * t4
      t120 = t119 * t14
      t122 = t119 * t5
      t124 = t119 * x
      t126 = -0.864D3 * t89 + 0.18288D5 * t91 - 0.6048D4 * t95 + 0.6048D
     #4 * t97 - 0.1296D4 * t101 + 0.1296D4 * t103 - 0.5400D4 * t106 + 0.
     #12744D5 * t108 + 0.6696D4 * t110 - 0.216D3 * t113 - 0.648D3 * t115
     # + 0.648D3 * t117 - 0.3024D4 * t120 - 0.2592D4 * t122 + 0.2592D4 *
     # t124
      t127 = t4 ** 2
      t128 = t127 * t1
      t129 = t128 * t14
      t131 = t128 * t5
      t133 = t128 * x
      t143 = t68 * t4
      t162 = 0.6588D4 * t129 + 0.6372D4 * t131 - 0.6372D4 * t133 + 0.134
     #64D5 * t2 * t10 - 0.15840D5 * t82 * t10 - 0.2592D4 * t69 * t6 + 0.
     #2592D4 * t69 * t5 + 0.1728D4 * t143 * t6 - 0.1728D4 * t143 * t14 +
     # 0.3456D4 * t143 * x + 0.864D3 * t69 * t10 - 0.1728D4 * t143 * t10
     # - 0.6048D4 * t94 * t6 + 0.6048D4 * t94 * t5 - 0.3456D4 * t100 * t
     #6 + 0.3456D4 * t100 * t5
      t177 = Li2(t5)
      t178 = L * t177
      t195 = L * t127
      t198 = -0.14040D5 * t105 * t6 + 0.1080D4 * t112 * t6 + 0.2160D4 * 
     #t119 * t6 - 0.6156D4 * t128 * t6 + 0.2376D4 * t105 * t10 + 0.864D3
     # * t94 * t10 - 0.432D3 * t178 * t10 - 0.432D3 * t178 * t6 - 0.432D
     #3 * t178 * t14 + 0.432D3 * t178 * t5 + 0.432D3 * t178 * x - 0.6048
     #D4 * t2 * t4 + 0.864D3 * t25 * t2 + 0.1296D4 * t100 * t10 + 0.5184
     #D4 * t195 * t10
      t205 = t25 * t93
      t218 = t177 * t25
      t225 = t99 * t25
      t234 = -0.5184D4 * t195 * t6 + 0.5184D4 * t195 * t14 - 0.10368D5 *
     # t195 * x - 0.1728D4 * t205 * t10 - 0.1728D4 * t205 * t6 - 0.5616D
     #4 * t205 * t14 + 0.3024D4 * t205 * t5 + 0.3024D4 * t205 * x + 0.63
     #72D4 * t128 * t10 + 0.1944D4 * t218 * t14 - 0.648D3 * t218 * t5 - 
     #0.648D3 * t218 * x - 0.432D3 * t225 * t10 - 0.432D3 * t225 * t6 - 
     #0.2052D4 * t225 * t14 + 0.972D3 * t225 * t5
      t238 = t25 ** 2
      t239 = t1 * t238
      t246 = t1 * t177
      t259 = L * z2
      t264 = t259 * t14
      t268 = t259 * x
      t272 = 0.972D3 * t225 * x + 0.1944D4 * t239 * t14 - 0.648D3 * t239
     # * t5 - 0.648D3 * t239 * x + 0.216D3 * t246 * t10 - 0.216D3 * t246
     # * t6 - 0.1620D4 * t246 * t14 + 0.540D3 * t246 * t5 + 0.540D3 * t2
     #46 * x - 0.2592D4 * t119 * t10 - 0.2592D4 * t259 * t10 + 0.8640D4 
     #* t259 * t6 + 0.4320D4 * t264 - 0.6480D4 * t259 * t5 - 0.2160D4 * 
     #t268 - 0.648D3 * t112 * t10
      t273 = t50 * t6
      t277 = t25 * z2
      t288 = t4 * z2
      t293 = t288 * t14
      t295 = t288 * t5
      t297 = t288 * x
      t301 = t42 * t14
      t306 = 0.20700D5 * t273 - 0.21780D5 * t50 * t10 + 0.1728D4 * t277 
     #* t10 + 0.1728D4 * t277 * t6 + 0.3672D4 * t277 * t14 - 0.2376D4 * 
     #t277 * t5 - 0.2376D4 * t277 * x + 0.4968D4 * t288 * t10 - 0.5400D4
     # * t288 * t6 + 0.4536D4 * t293 + 0.648D3 * t295 - 0.9288D4 * t297 
     #- 0.7776D4 * t42 * t5 + 0.2592D4 * t301 - 0.1728D4 * t259 - 0.1782
     #0D5 * z2 * t10
      t310 = z2 * t6
      t312 = z2 * t14
      t314 = z2 * t5
      t316 = z2 * x
      t318 = z3 * t5
      t320 = z3 * x
      t326 = z3 * t14
      t331 = t1 * t6
      t333 = t1 * t14
      t335 = t1 * t5
      t337 = 0.14076D5 * t310 + 0.11592D5 * t312 - 0.11520D5 * t314 + 0.
     #6624D4 * t316 + 0.4320D4 * t318 + 0.11232D5 * t320 - 0.7128D4 * z3
     # * t10 + 0.3240D4 * z3 * t6 - 0.2808D4 * t326 - 0.2376D4 * t277 + 
     #0.4968D4 * t288 - 0.864D3 * t42 - 0.14238D5 * t331 - 0.4632D4 * t3
     #33 + 0.3432D4 * t335
      t338 = t1 * x
      t346 = t93 * t6
      t348 = t93 * t14
      t350 = t93 * t5
      t352 = t93 * x
      t365 = -0.18084D5 * t338 + 0.22728D5 * t7 + 0.1632D4 * t15 + 0.481
     #2D4 * t18 + 0.25908D5 * t21 + 0.4356D4 * t93 * t10 - 0.6444D4 * t3
     #46 - 0.7668D4 * t348 + 0.17460D5 * t350 + 0.2916D4 * t352 + 0.396D
     #3 * t177 * t10 + 0.756D3 * t177 * t6 - 0.828D3 * t177 * t14 - 0.12
     #60D4 * t177 * t5 + 0.432D3 * t177 * x - 0.23076D5 * t50
      t370 = t99 * t1
      t371 = t370 * x
      t375 = t99 * t5
      t377 = t99 * t14
      t379 = t99 * t6
      t383 = t99 * x
      t389 = t127 * t6
      t391 = t127 * t14
      t393 = 0.1008D4 * t57 + 0.2376D4 * t105 - 0.648D3 * t112 + 0.504D3
     # * t371 - 0.2592D4 * t119 + 0.6372D4 * t128 + 0.5580D4 * t375 - 0.
     #2304D4 * t377 - 0.8154D4 * t379 + 0.6732D4 * t99 * t10 - 0.4230D4 
     #* t383 + 0.24324D5 * t1 * t10 + 0.15840D5 * t127 * t10 - 0.16704D5
     # * t389 + 0.2448D4 * t391
      t394 = t127 * x
      t399 = Li3(x)
      t400 = t399 * t14
      t402 = t399 * t5
      t404 = t399 * x
      t406 = S12(x)
      t407 = t406 * t14
      t409 = t406 * t5
      t411 = t406 * x
      t413 = t370 * t14
      t415 = t127 * t5
      t423 = -0.18288D5 * t394 - 0.27540D5 * t11 + 0.5544D4 * t2 - 0.158
     #40D5 * t82 + 0.6264D4 * t400 - 0.16200D5 * t402 - 0.7560D4 * t404 
     #- 0.12312D5 * t407 + 0.11448D5 * t409 + 0.12744D5 * t411 - 0.504D3
     # * t413 + 0.864D3 * t415 + 0.864D3 * t69 - 0.1728D4 * t143 + 0.129
     #6D4 * t370 * t5 + 0.16848D5 * t399 * t6
      t430 = S12(t5)
      t441 = S12(-x)
      t452 = Li3(t5)
      t459 = -0.11016D5 * t406 * t6 - 0.1224D4 * t370 * t6 - 0.864D3 * t
     #430 * t10 - 0.864D3 * t430 * t6 - 0.864D3 * t430 * t14 + 0.864D3 *
     # t430 * t5 + 0.864D3 * t430 * x + 0.1728D4 * t441 * t10 + 0.1728D4
     # * t441 * t6 + 0.5616D4 * t441 * t14 - 0.3024D4 * t441 * t5 - 0.30
     #24D4 * t441 * x - 0.432D3 * t452 * t10 + 0.594D3 * t452 * t14 - 0.
     #54D2 * t452 * t5
      t462 = t127 * t4
      t484 = -0.54D2 * t452 * x - 0.3456D4 * t462 * t10 + 0.3456D4 * t46
     #2 * t6 - 0.3456D4 * t462 * t14 + 0.6912D4 * t462 * x - 0.864D3 * t
     #94 + 0.432D3 * t178 + 0.864D3 * t100 + 0.5184D4 * t195 + 0.3024D4 
     #* t205 - 0.648D3 * t218 + 0.972D3 * t225 - 0.648D3 * t239 + 0.540D
     #3 * t246 + 0.1080D4 * t406 * t10 - 0.1296D4 * t399 * t10
      t488 = L * t6
      t490 = L * t14
      t492 = L * t5
      t494 = L * x
      t496 = t68 * t6
      t498 = t68 * t14
      t500 = t68 * t5
      t502 = t68 * x
      t513 = 0.648D3 * t370 * t10 - 0.9078D4 * t488 - 0.2280D4 * t490 - 
     #0.3888D4 * t492 - 0.10686D5 * t494 - 0.2988D4 * t496 - 0.180D3 * t
     #498 - 0.576D3 * t500 - 0.3384D4 * t502 + 0.12966D5 * L * t10 + 0.3
     #564D4 * t68 * t10 + 0.21165D5 * t10 + 0.288D3 * t370 + 0.12414D5 *
     # t1 - 0.11412D5 * t93 + 0.1430D4 * t5
      t530 = 0.504D3 * t177 - 0.3456D4 * t462 - 0.27540D5 * t4 - 0.5832D
     #4 * t399 - 0.2376D4 * t406 + 0.864D3 * t430 - 0.3024D4 * t441 - 0.
     #54D2 * t452 - 0.2642D4 * t14 + 0.15840D5 * t127 - 0.19751D5 * t6 +
     # 0.2772D4 * t99 + 0.3564D4 * t68 + 0.12966D5 * L - 0.2160D4 * z2 -
     # 0.648D3 * z3
      t535 = 0.1D1 / x
      t538 = -0.1D1 / t3
      t553 = -0.14939D5 + 0.17921D5 * x + 0.5184D4 * t47 - 0.9396D4 * t5
     #1 + 0.6804D4 * t53 - 0.8856D4 * t55 + t71 - t73 - 0.3600D4 * t74 +
     # 0.8784D4 * t76 - 0.3024D4 * t78 - 0.1008D4 * t80 + 0.4896D4 * t83
      t567 = -0.5760D4 * t85 + 0.4320D4 * t89 - 0.8352D4 * t91 + 0.3456D
     #4 * t95 - 0.3456D4 * t97 + 0.1728D4 * t101 - 0.1728D4 * t103 + 0.5
     #076D4 * t106 + 0.324D3 * t108 - 0.5616D4 * t110 + 0.108D3 * t113 -
     # 0.324D3 * t115 + 0.432D3 * t117
      t582 = -0.54D2 * t120 + 0.162D3 * t122 - 0.216D3 * t124 + 0.54D2 *
     # t129 - 0.162D3 * t131 + 0.216D3 * t133 - 0.3456D4 * t264 + 0.3456
     #D4 * t268 + 0.7344D4 * t273 - 0.108D3 * t293 + 0.324D3 * t295 - 0.
     #432D3 * t297 - 0.5184D4 * t301
      t596 = 0.4752D4 * t310 - 0.13932D5 * t312 + 0.3564D4 * t314 + 0.25
     #20D4 * t316 + 0.648D3 * t318 + 0.2592D4 * t320 - 0.3672D4 * t326 +
     # 0.216D3 * t288 - 0.14304D5 * t331 + 0.18246D5 * t333 - 0.1998D4 *
     # t335 + 0.3588D4 * t338 + 0.18840D5 * t7
      t612 = -0.21828D5 * t15 + 0.6516D4 * t18 - 0.18912D5 * t21 + 0.144
     #D3 * t346 + 0.8172D4 * t348 + 0.756D3 * t350 - 0.10872D5 * t352 + 
     #0.7344D4 * t50 + 0.216D3 * t105 - 0.216D3 * t112 - 0.720D3 * t371 
     #+ 0.108D3 * t119 - 0.108D3 * t128
      t626 = -0.2106D4 * t375 + 0.6318D4 * t377 - 0.2376D4 * t379 - 0.93
     #6D3 * t383 - 0.4896D4 * t389 + 0.5760D4 * t391 + 0.8352D4 * t394 -
     # 0.2448D4 * t2 + 0.4896D4 * t82 - 0.3348D4 * t400 - 0.324D3 * t402
     # + 0.3888D4 * t404 + 0.7020D4 * t407
      t641 = -0.324D3 * t409 - 0.6480D4 * t411 + 0.720D3 * t413 - 0.4320
     #D4 * t415 - 0.9420D4 * t488 + 0.10752D5 * t490 - 0.3096D4 * t492 +
     # 0.9456D4 * t494 - 0.1224D4 * t496 + 0.1440D4 * t498 - 0.1080D4 * 
     #t500 + 0.2088D4 * t502 - 0.7692D4 * t1
      t655 = 0.2448D4 * t93 - 0.6783D4 * t5 + 0.15384D5 * t4 - 0.216D3 *
     # t399 - 0.216D3 * t406 + 0.21575D5 * t14 - 0.4896D4 * t127 - 0.177
     #74D5 * t6 - 0.1224D4 * t99 - 0.1224D4 * t68 - 0.7692D4 * L + 0.244
     #8D4 * z2 + 0.432D3 * z3
      EggNNLO = (t49 + t87 + t126 + t162 + t198 + t234 + t272 
     $ + t306 + t337 +
     # t365 + t393 + t423 + t459 + t484 + t513 + t530) * t535 * t538 / t
     #24 / 0.48D2 + (t553 + t567 + t582 + t596 + t612 + t626 + t641 + t6
     #55) * t538 * t535 * NF / 0.1296D4

      endif
      !print*,EggNNLO,whichpart
      end



c=========================================================================	
c=========================================================================
c=========================================================================
c
c              old implementation of gg channel below
c
c=========================================================================
c=========================================================================
c=========================================================================
cc
cc     double precision function ggdelta(z,QQQ,wlo)
cc     implicit none 
cc     double precision QQQ,ggdelta_LO_exact,gg_n0_delta
cc     double precision gg_n1_delta,gg_n2_delta
cc     double precision z,ggdelta_NLO_exact
cc     integer wlo
cc     double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
cc     double precision WC2NNLO,WC0NNNLO,WC1NNNLO,WC2NNNLO
cc     double precision WC3NNNLO
cc     common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
cc     #    ,WC0NNNLO,WC1NNNLO,WC2NNNLO,WC3NNNLO
cc     c ------- 
cc     !: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
cc     integer effective_theory_flag
cc     common /common_eff_theory_flag/ effective_theory_flag
cc     c -------
cc     !print*,WC0NNLO,WC1NNLO,WC2NNLO
cc
cc     if (effective_theory_flag.eq.0) then 
cc     select case (wlo)
cc     case(0)
cc     ggdelta = ggdelta_LO_exact(QQQ) 
cc     #				+ WC0LO * gg_n0_delta()
cc     case(1)
cc     ggdelta = ggdelta_NLO_exact(QQQ)
cc     #				+ WC1NLO * gg_n0_delta() 
cc     #				+ WC0NLO * gg_n1_delta() 
cc     case(2)
cc     ggdelta = WC2NNLO * gg_n0_delta() 
cc     #				+ WC1NNLO * gg_n1_delta()
cc     #				+ WC0NNLO * gg_n2_delta()
cc     end select
cc     elseif (effective_theory_flag.eq.1) then
cc     select case (wlo)
cc     case(0)
cc     ggdelta =   WC0LO * gg_n0_delta()
cc     case(1)
cc     ggdelta =  WC1NLO * gg_n0_delta() 
cc     #				+ WC0NLO * gg_n1_delta() 
cc     case(2)
cc     ggdelta = WC2NNLO * gg_n0_delta() 
cc     #				+ WC1NNLO * gg_n1_delta()
cc     #				+ WC0NNLO * gg_n2_delta()
cc     c	print*,'ggdelta NNLO = ',ggdelta
cc     c	print*,'WC0NNLO=',WC0NNLO,'WC1NNLO=',WC1NNLO,'WC2NNLO=',WC2NNLO
cc     c	print*,'n0=',gg_n0_delta(),'n1=',gg_n1_delta(),'n2=',gg_n2_delta()
cc     end select
cc     endif
cc     !print*,"ggdelta=",ggdelta,WC0LO,ggdelta_LO_exact(QQQ)
cc
cc     end
cc
cc
ccc=========================================================================	
cc     double precision function gg_n0_delta()
cc     gg_n0_delta = 1d0
cc     end
ccc=========================================================================	
cc	double precision function gg_n1_delta()
cc	implicit double precision (t)
cc	double precision L, Lt, Lr, NF
cc      common /xsection/ L, Lt, Lr, NF
cc	double precision pi,z2,z3,z4
cc	common /consts/ pi, z2, z3
cc	
cc      EggNLO_delta = 6d0*z2
cc     
cc	t2 = -11d0/2d0 + NF/3d0
cc      gg_n1_delta = t2 * L - t2 * Lr + 6d0 * z2
cc	end
ccc=========================================================================	
cc	double precision function gg_n2_delta()
cc	implicit double precision (t)
cc	double precision L, Lt, Lr, NF
cc      common /xsection/ L, Lt, Lr, NF
cc	double precision pi,z2,z3,z4
cc	common /consts/ pi, z2, z3
cc	z4=1.082323234d0
cc	
cc      EggNNLO_delta =0.33D2 / 0.2D1 * L * z2 
cc     #- 0.171D3 / 0.2D1 * L * z3 + 0.27D2 
cc     #/ 0.2D1 * L - 0.18D2 * z2 * L ** 2 + 0.1071D4 / 0.8D1 * z4 - 0.54D
cc     #2 * z2 ** 2 + 0.67D2 / 0.2D1 * z2 - 0.165D3 / 0.4D1 * z3 + 0.837D3
cc     # / 0.16D2 + (-L * z2 - 0.11D2 / 0.6D1 * L - 0.5D1 / 0.3D1 * z2 + 0
cc     #.5D1 / 0.6D1 * z3 - 0.247D3 / 0.36D2) * NF
cc
cc	
cc		
cc
cc	gg_n2_delta = 
cc	end
cc
ccc=========================================================================	
cc      double  precision function gg_n3_delta()
cc      implicit double precision (t)
cc      double precision L, Lt, Lr, NF
cc      common /xsection/ L, Lt, Lr, NF
cc      double precision pi,z2,z3,z4
cc      common /consts/ pi, z2, z3
cc      z4=1.082323234d0
cc
cc      
cc
cc  
cc
cc
cc      gg_n3_delta = 0d0
cc      end
cc
cc
cc
ccc====================================================================
ccc
ccc		ggplus
ccc
ccc====================================================================
cc      double precision function ggplus(z,QQQ,wlo)
cc      implicit none 
cc      double precision QQQ,ggplus_LO_exact
cc	double precision gg_n1_plus,gg_n2_plus,gg_n3_plus
cc      double precision z
cc      integer wlo
cc	double complex sborn_mass
cc          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
cc          double precision WC2NNLO,WC0NNNLO,WC1NNNLO,WC2NNNLO
cc          double precision WC3NNNLO
cc          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
cc     #    ,WC0NNNLO,WC1NNNLO,WC2NNNLO,WC3NNNLO
ccc ------- 
cc	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
cc	integer effective_theory_flag
cc	common /common_eff_theory_flag/ effective_theory_flag
ccc -------
cc	
cc	if (effective_theory_flag.eq.0) then 
cc		select case (wlo)
cc		case(0)
cc			ggplus = 0d0
cc		case(1)
cc			ggplus = gg_n1_plus(z)* abs(sborn_mass(QQQ))**2 ! NLO exact
cc     #				+ WC0NLO * gg_n1_plus(z) 
cc		case(2)
cc			ggplus =  WC1NNLO * gg_n1_plus(z)
cc     #				+ WC0NNLO * gg_n2_plus(z)
cc          case(3)
cc               ggplus =    WC2NNNLO * gg_n1_plus(z)
cc     #				+ WC1NNNLO * gg_n2_plus(z)
cc     #                   + WC0NNNLO * gg_n3_plus(z)
cc		end select
cc	elseif (effective_theory_flag.eq.1) then
cc		select case (wlo)
cc		case(0)
cc			ggplus =   0d0
cc		case(1)
cc			ggplus =   WC0NLO * gg_n1_plus(z) 
cc		case(2)
cc			ggplus = WC1NNLO * gg_n1_plus(z)
cc     #				+ WC0NNLO * gg_n2_plus(z)
cc          case(3)
cc               ggplus =    WC2NNNLO * gg_n1_plus(z)
cc     #				+ WC1NNNLO * gg_n2_plus(z)
cc     #                   + WC0NNNLO * gg_n3_plus(z)
cc		end select
cc
cc	endif
cc      end
cc
cc
ccc=========================================================================	
cc	double precision function gg_n1_plus(z)
cc	implicit none
cc	double precision L, Lt, Lr, NF,z
cc      common /xsection/ L, Lt, Lr, NF
cc	double precision pi,z2,z3,z4
cc	common /consts/ pi, z2, z3
cc	double precision LLz,DD0,DD1,DD2,DD3
cc	
cc      z4=1.082323234d0
cc	 
cc	
cc	 DD0=1d0
cc      DD1=LLz
cc      EggNLO_plus = -6d0 * L * DD0 + 12d0 * DD1 
cc	gg_n1_plus = EggNLO_plus
cc	
cc	end
ccc=========================================================================	
cc	
cc	
cc	double precision function gg_n2_plus(z)
cc	implicit double precision (t)
cc	double precision L, Lt, Lr, NF,z
cc      common /xsection/ L, Lt, Lr, NF
cc	double precision pi,z2,z3,z4
cc	common /consts/ pi, z2, z3
cc	double precision LLz,DD0,DD1,DD2,DD3
cc	
cc      z4=1.082323234d0
cc	
cc	LLz = dlog(1d0-z)
cc	DD0=1d0
cc      DD1=LLz
cc	DD2=LLz**2
cc      DD3=LLz**3
cc	
cc
cc     EggNNLO_plus = (DD0 * L ** 2 / 0.2D1 
cc     $+ 0.5D1 / 0.3D1 * L * DD0 - 0.2D1 * DD
cc     #0 * z2 + 0.14D2 / 0.9D1 * DD0 - 0.2D1 * DD1 * L - 0.10D2 / 0.3D1 *
cc     # DD1 + dble(2 * DD2)) * NF + 0.351D3 / 0.2D1 * DD0 * z3 + 0.33D2 *
cc     # DD0 * z2 - 0.101D3 / 0.3D1 * DD0 + 0.45D2 * DD0 * L * z2 - 0.67D2
cc     # / 0.2D1 * L * DD0 - 0.33D2 / 0.4D1 * DD0 * L ** 2 - 0.90D2 * DD1 
cc     #* z2 + 0.67D2 * DD1 + 0.33D2 * DD1 * L + 0.36D2 * DD1 * L ** 2 - d
cc     #ble(33 * DD2) - 0.108D3 * dble(DD2) * L + dble(72 * DD3)
cc
cc	t3 = L ** 2
cc      t35 = ((0.165D3 / 0.4D1 - 0.5D1 / 0.2D1 * NF) * t3 + ((-0.99D2 / 0
cc     #.2D1 + 0.3D1 * NF) * Lr + dble(45 * z2) - 0.67D2 / 0.2D1 + 0.5D1 /
cc     # 0.3D1 * NF) * L + 0.351D3 / 0.2D1 * z3 + dble(33 * z2) - 0.101D3 
cc     #/ 0.3D1 + (-dble(2 * z2) + 0.14D2 / 0.9D1) * NF) * DD0 + (0.36D2 *
cc     # t3 + (-0.66D2 + 0.4D1 * NF) * L + (0.99D2 - 0.6D1 * NF) * Lr - 0.
cc     #10D2 / 0.3D1 * NF - dble(90 * z2) + 0.67D2) * DD1 + (-0.33D2 - 0.1
cc     #08D3 * L + 0.2D1 * NF) * DD2 + dble(72 * DD3)
cc
cc	gg_n2_plus = t35
cc
cc	
cc	end
cc
cc
ccccc   plus distribution terms from Moch and Vogt http:ccarXiv.org/abs/hep-ph/0508265v2
cc      double precision function gg_n3_plus(z)
cc      implicit double precision (t)
cc      double precision L, Lt, Lr, NF,z
cc      common /xsection/ L, Lt, Lr, NF
cc      double precision pi,z2,z3,z4
cc      common /consts/ pi, z2, z3
cc      double precision LLz,DD0,DD1,DD2,DD3,Lsq
cc
cc      z4=1.082323234d0
cc
cc      LLz = dlog(1d0-z)
cc      DD0=1d0
cc      DD1=LLz
cc      DD2=LLz**2
cc      DD3=LLz**3
cc      DD4=LLZ**4
cc      DD5=LLZ**5
cc
cc      Lsq = L ** 2
cc
cc      c3_5 = 216d0
cc      c3_4 = -330d0+20d0*NF
cc      c3_3 = 925d0-1512d0*z2-(164d0/3d0)*NF+(4d0/9d0)*NF**2
cc      c3_2 = -1051d0+1683d0*z2+4887d0*z3 
cc     &         +(469d0/6d0-102d0*z2)*NF 
cc     &         -(10d0/9d0)*NF**2
cc      c3_1 =  (25d0/27d0-(4d0/3d0)*z2)*NF**2
cc     &         +(-5345d0/36d0+162d0*z3+94d0*z2)*NF
cc     &         +30569d0/24d0-1368d0*z2-3168d0*z3-(4158d0/5d0)*z2**2
cc      c3_0 =   (-58d0/243d0+(10d0/9d0)*z2+(5d0/9d0)*z3)*NF**2
cc     &         +(
cc     &             41579d0/1296d0-(2245d0/36d0)*z2
cc     &             -(4427d0/36d0)*z3-(59d0/10d0)*z2**2
cc     &         )*NF
cc     &         +(
cc     &             -297029d0/864d0+(8563d0/12d0)*z2
cc     &             +(8941d0/4d0)*z3+(2277d0/20d0)*z2**2
cc     &             -(6525d0/2d0)*z2*z3+5022d0*z5
cc     &          )   
cc
cc      gg_n3_plus = c3_0 * DD0 + c3_1 * DD1 + c3_2*DD2 + c3_3*DD3
cc     &                +c3_4*DD4+c3_5*DD5
cc
cc
cc
cc       end 
ccc====================================================================
ccc
ccc		ggreg
ccc
ccc====================================================================
cc
cc      double precision function ggreg(z,lambda,QQQ,wlo)
cc      implicit none 
cc      double precision QQQ,ggreg_exact_NLO
cc	double precision gg_n1_reg,gg_n2_reg
cc      double precision z,lambda
cc      integer wlo
cc          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
cc          double precision WC2NNLO,WC0NNNLO,WC1NNNLO,WC2NNNLO
cc          double precision WC3NNNLO
cc          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
cc     #    ,WC0NNNLO,WC1NNNLO,WC2NNNLO,WC3NNNLO
ccc ------- 
cc	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
cc	integer effective_theory_flag
cc	common /common_eff_theory_flag/ effective_theory_flag
ccc -------
cc	
cc	if (effective_theory_flag.eq.0) then 
cc		select case (wlo)
cc		case(0)
cc			ggreg = 0d0
cc		case(1)
cc			ggreg = ggreg_exact_NLO(z,lambda,QQQ)
cc     #				+ WC0NLO * gg_n1_reg(z) 
cc		case(2)
cc			ggreg =  WC1NNLO * gg_n1_reg(z)
cc     #				+ WC0NNLO * gg_n2_reg(z)
cc		end select
cc	elseif (effective_theory_flag.eq.1) then
cc		select case (wlo)
cc		case(0)
cc			ggreg =   0d0
cc		case(1)
cc			ggreg =   WC0NLO * gg_n1_reg(z) 
cc		case(2)
cc			ggreg = WC1NNLO * gg_n1_reg(z)
cc     #				+ WC0NNLO * gg_n2_reg(z)
cc		end select
cc
cc	endif
cc      end
ccc=========================================================================	
cc
      double precision function ggreg_exact_NLO(z,lambda,QQQ)
      implicit none 
      double precision z,lambda,QQQ
      double precision lambda_limit,born_squared
      double precision hard_ampl,pgg,collinear,hard,ggreg_effective
      double complex real_ggg_ampl1,real_ggg_ampl2,real_ggg_ampl3
      double complex real_ggg_ampl4
      double complex sum_over_quarks,sborn_mass
      external Aq1,Aq2a,Aq2b,Aq2c
	double precision L, Lt, Lr, NF
      common /xsection/ L, Lt, Lr, NF

cc     regular part of NLO Real corrections with massive quarks

cc      ggreg_nlo = 1/2 * Nc * as/Pi * 
cc               [ z^4 S_q{ S_i |real_ggg_ampl_i|^2  } - (1-z+z^2) * 2 * S_q {|born_q|^2} ]
cc               -------------------------------------------------------------------------
cc                           z * (1-z) * lambda * (1-lambda)

c     sum_over_quarks: sums over all massive quarks the function
c     that is passed to it as its first argument and it also 
c     multiplies by a normalization factor Wq(i)*3d0/32d0/QQQ**2
c     which is tau_q*3/32/m_higgs^2 
        
         !call test_limits(QQQ)

         !call test_hard(QQQ)
	real_ggg_ampl1 =sum_over_quarks(Aq1,z,lambda,QQQ) 
	real_ggg_ampl2 =sum_over_quarks(Aq2a,z,lambda,QQQ)
	real_ggg_ampl3 =sum_over_quarks(Aq2b,z,lambda,QQQ)
	real_ggg_ampl4 =sum_over_quarks(Aq2c,z,lambda,QQQ)   
	hard_ampl = abs(real_ggg_ampl1)**2 + 
     #		abs(real_ggg_ampl2)**2 +
     #		abs(real_ggg_ampl3)**2 +
     #		abs(real_ggg_ampl4)**2
      
	born_squared = abs(sborn_mass(QQQ))**2  
      
	lambda_limit = (1d0-z+z**2)**2   *   born_squared
	hard =  3d0 *(1d0/2d0*z**4 * hard_ampl - lambda_limit ) 
     #              /z/(1d0-z)/lambda/(1d0-lambda)  
      !below: the regular piece coming from the integrated collinear counterterm
      !       and the renormalized PDF 
	pgg =1d0/z + z*(1d0-z) - 2d0
      
	collinear = born_squared  * 
     #                  ( 
     #                  6d0 * (pgg * dlog( (1d0-z)**2/z ) 
     #                          - dlog(z)/(1d0-z) 
     #                          )
     #                  -6d0*L*pgg
     #                  )
      
	ggreg_exact_NLO = hard + collinear  
c	ggreg_exact_NLO = collinear + born_squared*11d0/2d0*(z-1)**3/z          

c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10, and also lambda=1- 1e-10
c      call test_limits(QQQ)
      end

cc
cc	
ccc=========================================================================	
cc	 double precision function gg_n1_reg(x)
cc	 implicit double precision (t)
cc	 double precision L, Lt, Lr, NF,x
cc      common /xsection/ L, Lt, Lr, NF
cc	 double precision pi,z2,z3,z4
cc	 common /consts/ pi, z2, z3
cc	 double precision LLz,DD0,DD1,DD2,DD3
cc	
cc	 z4=1.082323234d0
cc      EggNLO_reg = (6*(x**3-x**2+2*x-1))*L/x
cc     $              +6*(x**2-x+1)**2*dlog(x)/((x-1)*x)
cc     $              +(11/2)*(x-1)**3/x
cc     $              -(12*(x**3-x**2+2*x-1))*dlog(1-x)/x
cc
cc
cc	t1 = x ** 2
cc      t5 = 0.1D1 / x
cc      t6 = (t1 * x - t1 + 0.2D1 * x - 0.1D1) * t5
cc      t10 = (t1 - x + 0.1D1) ** 2
cc      t11 = x - 0.1D1
cc      t14 = log(x)
cc      t18 = t11 ** 2
cc      t22 = log(-t11)
cc      t25 = 0.6D1 * t6 * L + 0.6D1 * t10 / t11 * t5 * t14 + 0.11D2 / 0.2
cc     #D1 * t18 * t11 * t5 - 0.12D2 * t6 * t22
cc
cc	gg_n1_reg = t25	
cc	end
ccc=========================================================================	
cc	
cc	
cc	double precision function gg_n2_reg(x)
cc	implicit double precision (t)
cc	double precision L, Lt, Lr, NF,x
cc      common /xsection/ L, Lt, Lr, NF
cc	double precision pi,z2,z3,z4
cc	common /consts/ pi, z2, z3
cc	double precision LLz,DD0,DD1,DD2,DD3
cc	double precision Li2,Li3,S12
cc	z4=1.082323234d0
cc	
cc     t2 = 1 - x
cc     t3 = dlog(dble(t2))
cc     t5 = int(Li3(x))
cc     t7 = int(S12(x))
cc     t9 = x ** 2
cc     t10 = int(S12(t9))
cc     t12 = int(S12(-x))
cc     t14 = int(Li3(t9))
cc     t16 = t9 * x
cc     t18 = t3 ** 2
cc     t20 = t9 ** 2
cc     t22 = dlog(dble(x))
cc     t23 = t22 ** 2
cc     t25 = int(L ** 2)
cc     t27 = t20 * x
cc     t29 = t23 * t22
cc     t31 = 0.18321D5 - dble(648 * z3) - 0.27540D5 * t3 - dble(5832 * t5
cc     #) - dble(2376 * t7) + dble(864 * t10) - dble(3024 * t12) - dble(54
cc     # * t14) - dble(2642 * t16) + 0.15840D5 * t18 - dble(19751 * t20) +
cc     # 0.2772D4 * t23 + dble(3564 * t25) + dble(21165 * t27) + 0.288D3 *
cc     # t29
cc     t33 = int(Li2(x))
cc     t36 = int(Li2(t9))
cc     t38 = t18 * t3
cc     t40 = z2 * t22
cc     t45 = t40 * dble(x)
cc     t47 = t3 * t22
cc     t48 = t47 * dble(t16)
cc     t50 = t47 * dble(t9)
cc     t52 = t47 * dble(x)
cc     t54 = x + 1
cc     t55 = dlog(dble(t54))
cc     t56 = t22 * t55
cc     t67 = 0.12414D5 * t22 - dble(11412 * t33) + dble(1430 * t9) + dble
cc     #(504 * t36) - 0.3456D4 * t38 + 0.8208D4 * t40 * dble(t20) - 0.4320
cc     #D4 * t40 * dble(t27) - 0.2592D4 * t45 - 0.1692D4 * t48 + 0.396D3 *
cc     # t50 + 0.21492D5 * t52 + 0.792D3 * t56 * dble(t27) + 0.1512D4 * t5
cc     #6 * dble(t20) - 0.1656D4 * t56 * dble(t16) - 0.2520D4 * t56 * dble
cc     #(t9) + 0.864D3 * t56 * dble(x)
cc     t69 = dble(t25) * t22
cc     t71 = 0.864D3 * t69 * dble(t16)
cc     t73 = 0.864D3 * t69 * dble(x)
cc     t74 = L * t22
cc     t75 = t74 * dble(t20)
cc     t77 = t74 * dble(t16)
cc     t79 = t74 * dble(t9)
cc     t81 = t74 * dble(x)
cc     t83 = L * t3
cc     t84 = t83 * dble(t20)
cc     t86 = t83 * dble(t16)
cc     t88 = t83 * dble(t9)
cc     t90 = t83 * dble(x)
cc     t92 = L * dble(t33)
cc     t93 = t92 * dble(t16)
cc     t95 = t92 * dble(x)
cc     t97 = L * t23
cc     t98 = t97 * dble(t16)
cc     t100 = t97 * dble(x)
cc     t102 = t22 * dble(t33)
cc     t103 = t102 * dble(t16)
cc     t105 = -t71 + t73 - 0.11952D5 * t75 - 0.5328D4 * t77 + 0.7200D4 * 
cc     #t79 - 0.7344D4 * t81 + 0.16704D5 * t84 - 0.2448D4 * t86 - 0.864D3 
cc     #* t88 + 0.18288D5 * t90 - 0.6048D4 * t93 + 0.6048D4 * t95 - 0.1296
cc     #D4 * t98 + 0.1296D4 * t100 - 0.5400D4 * t103
cc     t106 = t102 * dble(t9)
cc     t108 = t102 * dble(x)
cc     t110 = t3 * dble(t33)
cc     t111 = t110 * dble(t16)
cc     t113 = t110 * dble(t9)
cc     t115 = t110 * dble(x)
cc     t117 = t23 * t3
cc     t118 = t117 * dble(t16)
cc     t120 = t117 * dble(t9)
cc     t122 = t117 * dble(x)
cc     t124 = t18 * t22
cc     t125 = t124 * dble(t16)
cc     t127 = t124 * dble(t9)
cc     t129 = t124 * dble(x)
cc     t139 = dble(t25) * t3
cc     t142 = 0.12744D5 * t106 + 0.6696D4 * t108 - 0.216D3 * t111 - 0.648
cc     #D3 * t113 + 0.648D3 * t115 - 0.3024D4 * t118 - 0.2592D4 * t120 + 0
cc     #.2592D4 * t122 + 0.6588D4 * t125 + 0.6372D4 * t127 - 0.6372D4 * t1
cc     #29 + 0.13464D5 * t74 * dble(t27) - 0.15840D5 * t83 * dble(t27) - 0
cc     #.2592D4 * t69 * dble(t20) + 0.2592D4 * t69 * dble(t9) + 0.1728D4 *
cc     # t139 * dble(t20)
cc     t173 = L * dble(t36)
cc     t176 = -0.1728D4 * t139 * dble(t16) + 0.3456D4 * t139 * dble(x) + 
cc     #0.864D3 * t69 * dble(t27) - 0.1728D4 * t139 * dble(t27) - 0.6048D4
cc     # * t92 * dble(t20) + 0.6048D4 * t92 * dble(t9) - 0.3456D4 * t97 * 
cc     #dble(t20) + 0.3456D4 * t97 * dble(t9) - 0.14040D5 * t102 * dble(t2
cc     #0) + 0.1080D4 * t110 * dble(t20) + 0.2160D4 * t117 * dble(t20) - 0
cc     #.6156D4 * t124 * dble(t20) + 0.2376D4 * t102 * dble(t27) + 0.864D3
cc     # * t92 * dble(t27) - 0.432D3 * t173 * dble(t27)
cc     t191 = L * t18
cc     t200 = t55 * dble(t33)
cc     t211 = -0.432D3 * t173 * dble(t20) - 0.432D3 * t173 * dble(t16) + 
cc     #0.432D3 * t173 * dble(t9) + 0.432D3 * t173 * dble(x) - 0.6048D4 * 
cc     #t74 * t3 + 0.864D3 * t74 * t55 + 0.1296D4 * t97 * dble(t27) + 0.51
cc     #84D4 * t191 * dble(t27) - 0.5184D4 * t191 * dble(t20) + 0.5184D4 *
cc     # t191 * dble(t16) - 0.10368D5 * t191 * dble(x) - 0.1728D4 * t200 *
cc     # dble(t27) - 0.1728D4 * t200 * dble(t20) - 0.5616D4 * t200 * dble(
cc     #t16) + 0.3024D4 * t200 * dble(t9) + 0.3024D4 * t200 * dble(x)
cc     t215 = dble(t36) * t55
cc     t222 = t23 * t55
cc     t233 = t55 ** 2
cc     t234 = t22 * t233
cc     t241 = t22 * dble(t36)
cc     t250 = 0.6372D4 * t124 * dble(t27) + 0.1944D4 * t215 * dble(t16) -
cc     # 0.648D3 * t215 * dble(t9) - 0.648D3 * t215 * dble(x) - 0.432D3 * 
cc     #t222 * dble(t27) - 0.432D3 * t222 * dble(t20) - 0.2052D4 * t222 * 
cc     #dble(t16) + 0.972D3 * t222 * dble(t9) + 0.972D3 * t222 * dble(x) +
cc     # 0.1944D4 * t234 * dble(t16) - 0.648D3 * t234 * dble(t9) - 0.648D3
cc     # * t234 * dble(x) + 0.216D3 * t241 * dble(t27) - 0.216D3 * t241 * 
cc     #dble(t20) - 0.1620D4 * t241 * dble(t16) + 0.540D3 * t241 * dble(t9
cc     #)
cc     t255 = L * z2
cc     t260 = t255 * dble(t16)
cc     t264 = t255 * dble(x)
cc     t268 = t47 * dble(t20)
cc     t272 = t55 * z2
cc     t283 = t3 * z2
cc     t286 = 0.540D3 * t241 * dble(x) - 0.2592D4 * t117 * dble(t27) - 0.
cc     #2592D4 * t255 * dble(t27) + 0.8640D4 * t255 * dble(t20) + 0.4320D4
cc     # * t260 - 0.6480D4 * t255 * dble(t9) - 0.2160D4 * t264 - 0.648D3 *
cc     # t110 * dble(t27) + 0.20700D5 * t268 - 0.21780D5 * t47 * dble(t27)
cc     # + 0.1728D4 * t272 * dble(t27) + 0.1728D4 * t272 * dble(t20) + 0.3
cc     #672D4 * t272 * dble(t16) - 0.2376D4 * t272 * dble(t9) - 0.2376D4 *
cc     # t272 * dble(x) + 0.4968D4 * t283 * dble(t27)
cc     t292 = t283 * dble(t16)
cc     t294 = t283 * dble(t9)
cc     t296 = t283 * dble(x)
cc     t300 = t40 * dble(t16)
cc     t302 = t3 * dble(t20)
cc     t305 = t3 * dble(t27)
cc     t308 = t3 * dble(t16)
cc     t311 = t3 * dble(t9)
cc     t314 = t3 * dble(x)
cc     t329 = -0.5400D4 * t283 * dble(t20) + 0.4536D4 * t292 + 0.648D3 * 
cc     #t294 - 0.9288D4 * t296 - 0.7776D4 * t40 * dble(t9) + 0.2592D4 * t3
cc     #00 + 0.6048D4 * t74 * t302 - 0.6048D4 * t74 * t305 - 0.6048D4 * t7
cc     #4 * t308 - 0.6048D4 * t74 * t311 + 0.6048D4 * t74 * t314 - 0.864D3
cc     # * t74 * t55 * dble(t27) - 0.864D3 * t74 * t55 * dble(t20) - 0.864
cc     #D3 * t74 * t55 * dble(t16) + 0.864D3 * t74 * t55 * dble(t9)
cc     t339 = z2 * dble(t20)
cc     t341 = z2 * dble(t16)
cc     t343 = z2 * dble(t9)
cc     t345 = z2 * dble(x)
cc     t347 = z3 * t9
cc     t349 = z3 * x
cc     t355 = z3 * t16
cc     t358 = 0.864D3 * t74 * t55 * dble(x) - dble(18523 * x) + 0.12966D5
cc     # * L - 0.2160D4 * z2 - 0.1728D4 * t255 - 0.17820D5 * z2 * dble(t27
cc     #) + 0.14076D5 * t339 + 0.11592D5 * t341 - 0.11520D5 * t343 + 0.662
cc     #4D4 * t345 + dble(4320 * t347) + dble(11232 * t349) - dble(7128 * 
cc     #z3 * t27) + dble(3240 * z3 * t20) - dble(2808 * t355) - 0.2376D4 *
cc     # t272
cc     t362 = dble(t20) * t22
cc     t364 = t22 * dble(t16)
cc     t366 = t22 * dble(t9)
cc     t368 = t22 * dble(x)
cc     t376 = t33 * t20
cc     t378 = t33 * t16
cc     t380 = t33 * t9
cc     t382 = t33 * x
cc     t384 = 0.4968D4 * t283 - 0.864D3 * t40 - 0.14238D5 * t362 - 0.4632
cc     #D4 * t364 + 0.3432D4 * t366 - 0.18084D5 * t368 + 0.22728D5 * t302 
cc     #+ 0.1632D4 * t308 + 0.4812D4 * t311 + 0.25908D5 * t314 + dble(4356
cc     # * t33 * t27) - dble(6444 * t376) - dble(7668 * t378) + dble(17460
cc     # * t380) + dble(2916 * t382)
cc     t399 = t29 * dble(x)
cc     t403 = t23 * dble(t9)
cc     t405 = t23 * dble(t16)
cc     t407 = t23 * dble(t20)
cc     t411 = dble(396 * t36 * t27) + dble(756 * t36 * t20) - dble(828 * 
cc     #t36 * t16) - dble(1260 * t36 * t9) + dble(432 * t36 * x) - 0.23076
cc     #D5 * t47 + 0.1008D4 * t56 + 0.2376D4 * t102 - 0.648D3 * t110 + 0.5
cc     #04D3 * t399 - 0.2592D4 * t117 + 0.6372D4 * t124 + 0.5580D4 * t403 
cc     #- 0.2304D4 * t405 - 0.8154D4 * t407 + 0.6732D4 * t23 * dble(t27)
cc     t414 = t23 * dble(x)
cc     t420 = t18 * dble(t20)
cc     t422 = t18 * dble(t16)
cc     t424 = t18 * dble(x)
cc     t429 = t5 * t16
cc     t431 = t5 * t9
cc     t433 = t5 * x
cc     t435 = t7 * t16
cc     t437 = t7 * t9
cc     t439 = t7 * x
cc     t441 = -0.4230D4 * t414 + 0.24324D5 * t22 * dble(t27) + 0.15840D5 
cc     #* t18 * dble(t27) - 0.16704D5 * t420 + 0.2448D4 * t422 - 0.18288D5
cc     # * t424 - 0.27540D5 * t305 + 0.5544D4 * t74 - 0.15840D5 * t83 + db
cc     #le(6264 * t429) - dble(16200 * t431) - dble(7560 * t433) - dble(12
cc     #312 * t435) + dble(11448 * t437) + dble(12744 * t439)
cc     t442 = t29 * dble(t16)
cc     t444 = t18 * dble(t9)
cc     t472 = -0.504D3 * t442 + 0.864D3 * t444 + 0.864D3 * t69 - 0.1728D4
cc     # * t139 + 0.1296D4 * t29 * dble(t9) + dble(16848 * t5 * t20) - dbl
cc     #e(11016 * t7 * t20) - 0.1224D4 * t29 * dble(t20) - dble(864 * t10 
cc     #* t27) - dble(864 * t20 * t10) - dble(864 * t10 * t16) + dble(864 
cc     #* t10 * t9) + dble(864 * t10 * x) + dble(1728 * t12 * t27) + dble(
cc     #1728 * t12 * t20) + dble(5616 * t12 * t16)
cc     t500 = -dble(3024 * t12 * t9) - dble(3024 * t12 * x) - dble(432 * 
cc     #t14 * t27) + dble(594 * t14 * t16) - dble(54 * t14 * t9) - dble(54
cc     # * t14 * x) - 0.3456D4 * t38 * dble(t27) + 0.3456D4 * t38 * dble(t
cc     #20) - 0.3456D4 * t38 * dble(t16) + 0.6912D4 * t38 * dble(x) - 0.86
cc     #4D3 * t92 + 0.432D3 * t173 + 0.864D3 * t97 + 0.5184D4 * t191 + 0.3
cc     #024D4 * t200 - 0.648D3 * t215
cc     t510 = L * dble(t20)
cc     t512 = L * dble(t16)
cc     t514 = L * dble(t9)
cc     t516 = L * dble(x)
cc     t518 = t25 * t20
cc     t520 = t25 * t16
cc     t522 = t25 * t9
cc     t524 = t25 * x
cc     t530 = 0.972D3 * t222 - 0.648D3 * t234 + 0.540D3 * t241 + dble(108
cc     #0 * t7 * t27) - dble(1296 * t5 * t27) + 0.648D3 * t29 * dble(t27) 
cc     #- 0.9078D4 * t510 - 0.2280D4 * t512 - 0.3888D4 * t514 - 0.10686D5 
cc     #* t516 - dble(2988 * t518) - dble(180 * t520) - dble(576 * t522) -
cc     # dble(3384 * t524) + 0.12966D5 * L * dble(t27) + dble(3564 * t25 *
cc     # t27)
cc     t535 = 1 / x
cc     t538 = -1 / t2
cc     t555 = -0.14939D5 + dble(432 * z3) + 0.15384D5 * t3 - dble(216 * t
cc     #5) - dble(216 * t7) + dble(21575 * t16) - 0.4896D4 * t18 - dble(17
cc     #774 * t20) - 0.1224D4 * t23 - dble(1224 * t25) - 0.7692D4 * t22 + 
cc     #dble(2448 * t33) - dble(6783 * t9)
cc     t567 = 0.5184D4 * t45 - 0.9396D4 * t48 + 0.6804D4 * t50 - 0.8856D4
cc     # * t52 + t71 - t73 - 0.3600D4 * t75 + 0.8784D4 * t77 - 0.3024D4 * 
cc     #t79 - 0.1008D4 * t81 + 0.4896D4 * t84 - 0.5760D4 * t86 + 0.4320D4 
cc     #* t88
cc     t582 = -0.8352D4 * t90 + 0.3456D4 * t93 - 0.3456D4 * t95 + 0.1728D
cc     #4 * t98 - 0.1728D4 * t100 + 0.5076D4 * t103 + 0.324D3 * t106 - 0.5
cc     #616D4 * t108 + 0.108D3 * t111 - 0.324D3 * t113 + 0.432D3 * t115 - 
cc     #0.54D2 * t118 + 0.162D3 * t120
cc     t596 = -0.216D3 * t122 + 0.54D2 * t125 - 0.162D3 * t127 + 0.216D3 
cc     #* t129 - 0.3456D4 * t260 + 0.3456D4 * t264 + 0.7344D4 * t268 - 0.1
cc     #08D3 * t292 + 0.324D3 * t294 - 0.432D3 * t296 - 0.5184D4 * t300 + 
cc     #dble(17921 * x) - 0.7692D4 * L
cc     t612 = 0.2448D4 * z2 + 0.4752D4 * t339 - 0.13932D5 * t341 + 0.3564
cc     #D4 * t343 + 0.2520D4 * t345 + dble(648 * t347) + dble(2592 * t349)
cc     # - dble(3672 * t355) + 0.216D3 * t283 - 0.14304D5 * t362 + 0.18246
cc     #D5 * t364 - 0.1998D4 * t366 + 0.3588D4 * t368
cc     t626 = 0.18840D5 * t302 - 0.21828D5 * t308 + 0.6516D4 * t311 - 0.1
cc     #8912D5 * t314 + dble(144 * t376) + dble(8172 * t378) + dble(756 * 
cc     #t380) - dble(10872 * t382) + 0.7344D4 * t47 + 0.216D3 * t102 - 0.2
cc     #16D3 * t110 - 0.720D3 * t399 + 0.108D3 * t117
cc     t641 = -0.108D3 * t124 - 0.2106D4 * t403 + 0.6318D4 * t405 - 0.237
cc     #6D4 * t407 - 0.936D3 * t414 - 0.4896D4 * t420 + 0.5760D4 * t422 + 
cc     #0.8352D4 * t424 - 0.2448D4 * t74 + 0.4896D4 * t83 - dble(3348 * t4
cc     #29) - dble(324 * t431) + dble(3888 * t433)
cc     t655 = dble(7020 * t435) - dble(324 * t437) - dble(6480 * t439) + 
cc     #0.720D3 * t442 - 0.4320D4 * t444 - 0.9420D4 * t510 + 0.10752D5 * t
cc     #512 - 0.3096D4 * t514 + 0.9456D4 * t516 - dble(1224 * t518) + dble
cc     #(1440 * t520) - dble(1080 * t522) + dble(2088 * t524)
cc     EggNNLO_reg = (t31 + t67 + t105 + t142 + t176 + t211 
cc     #+ t250 + t286 + t329 +
cc     # t358 + t384 + t411 + t441 + t472 + t500 + t530) * dble(t535) * db
cc     #le(t538) / dble(t54) / 0.48D2 + (t555 + t567 + t582 + t596 + t612 
cc     #+ t626 + t641 + t655) * dble(t538) * dble(t535) * NF / 0.1296D4
cc
cc
cc
cc
cc     t1 = x ** 2
cc      t2 = t1 * x
cc      t7 = 0.1D1 / x
cc      t10 = x + 0.1D1
cc      t11 = log(x)
cc      t16 = 0.17D2 * t1
cc      t21 = t1 ** 2
cc      t23 = 0.3D1 * t1
cc      t26 = x - 0.1D1
cc      t27 = 0.1D1 / t26
cc      t31 = 0.2D1 * x
cc      t33 = (t2 - t1 + t31 - 0.1D1) * t7
cc      t34 = log(-t26)
cc      t35 = t33 * t34
cc      t38 = L ** 2
cc      t41 = (t1 - x + 0.1D1) ** 2
cc      t42 = t41 * t27
cc      t43 = t7 * t11
cc      t44 = t42 * t43
cc      t46 = t26 ** 2
cc      t48 = t46 * t26 * t7
cc      t66 = t21 * x
cc      t68 = 0.7D1 * t2
cc      t69 = 0.18D2 * t1
cc      t72 = 0.1D1 / t10
cc      t73 = t27 * t72
cc      t74 = t11 ** 2
cc      t75 = t74 * t11
cc      t80 = 0.8D1 * t2
cc      t82 = 0.6D1 * x
cc      t85 = t7 * t34
cc      t86 = Li2(x)
cc      t90 = 0.2D1 * t21
cc      t95 = t72 * t11
cc      t96 = Li2(t1)
cc      t100 = 0.6D1 * t21
cc      t101 = 0.11D2 * t2
cc      t102 = 0.12D2 * x
cc      t105 = t7 * t74
cc      t119 = 0.4D1 * t21
cc      t120 = 0.21D2 * t1
cc      t121 = 0.14D2 * x
cc      t122 = t119 + t80 + t120 + t121 + 0.7D1
cc      t124 = log(t10)
cc      t135 = t34 ** 2
cc      t140 = t23 + t31 + 0.1D1
cc      t142 = t72 * t96
cc      t153 = S12(x)
cc      t165 = t124 ** 2
cc      t176 = Li3(x)
cc      t184 = (t101 + t120 - t102 - 0.14D2) * t7
cc      t187 = (((0.37D2 * t2 - 0.51D2 * t1 + 0.96D2 * x - 0.37D2) * t7 / 
cc     #0.18D2 + 0.2D1 / 0.3D1 * t11 * t10) * NF + 0.3D1 / 0.4D1 * (0.33D2
cc     # * t2 - t16 - 0.38D2 * x - 0.33D2) * t7 + 0.18D2 * (t21 - 0.4D1 * 
cc     #t2 + t23 + 0.1D1) * t7 * t27 * t11 - 0.36D2 * t35) * t38 + ((-0.3D
cc     #1 * t44 - 0.11D2 / 0.4D1 * t48 + 0.6D1 * t35) * NF + 0.99D2 / 0.2D
cc     #1 * t44 + 0.363D3 / 0.8D1 * t48 - 0.99D2 * t35) * Lr + (0.21165D5 
cc     #* t2 - 0.19751D5 * t1 + 0.18523D5 * x - 0.18321D5) * t7 / 0.48D2 +
cc     # 0.3D1 / 0.2D1 * (0.7D1 * x - 0.17D2 * t21 + 0.9D1 * t66 - t68 + t
cc     #69 + 0.4D1) * t7 * t73 * t75 - 0.9D1 / 0.2D1 * (0.3D1 * t21 - t80 
cc     #+ 0.9D1 * t1 - t82 + 0.3D1) * t27 * t85 * t86 + 0.9D1 / 0.4D1 * (t
cc     #90 - 0.15D2 * t1 - 0.10D2 * x - 0.5D1) * t7 * t95 * t96 - 0.9D1 * 
cc     #(t100 - t101 + t69 - t102 + 0.6D1) * t27 * t105 * t34 - 0.3D1 / 0.
cc     #4D1 * (0.1227D4 * t1 - 0.1180D4 * t2 + 0.605D3 * t21 - 0.1238D4 * 
cc     #x + 0.641D3) * t7 * t27 * t34 * t11 - 0.9D1 * t122 * t7 * t72 * t1
cc     #24 * t86 + 0.9D1 / 0.4D1 * (0.59D2 * t21 - 0.116D3 * t2 + 0.177D3 
cc     #* t1 - 0.118D3 * x + 0.59D2) * t27 * t7 * t135 * t11 + 0.27D2 / 0.
cc     #2D1 * t140 * t7 * t142 * t124 + 0.9D1 / 0.2D1 * (-0.57D2 * t2 + 0.
cc     #59D2 * x + 0.53D2 * t1 + 0.5D1 * t66 - 0.51D2 * t21 - 0.11D2) * t7
cc     # * t73 * t153 - 0.9D1 / 0.4D1 * (t119 + t80 + 0.27D2 * t1 + 0.18D2
cc     # * x + 0.9D1) * t72 * t105 * t124 + 0.27D2 / 0.2D1 * t140 * t72 * 
cc     #t43 * t165 - 0.9D1 / 0.2D1 * (-0.78D2 * t21 - 0.29D2 * t2 + 0.35D2
cc     # * x + 0.6D1 * t66 + 0.75D2 * t1 + 0.27D2) * t7 * t73 * t176 - 0.7
cc     #2D2 * t33 * t135 * t34 + 0.3D1 / 0.4D1 * t184 * t96
cc      t202 = 0.6D1 * t2
cc      t208 = t72 * z2
cc      t218 = t7 * z2
cc      t238 = t7 * t86
cc      t262 = (t1 + 0.1D1 + x) ** 2
cc      t263 = t262 * t72
cc      t264 = S12(t1)
cc      t269 = S12(-x)
cc      t273 = 0.8D1 * t21
cc      t276 = Li3(t1)
cc      t299 = 0.52D2 * x
cc      t321 = 0.61D2 * x
cc      t364 = t43 * t34
cc      t390 = (-0.3D1 * t33 * NF + 0.99D2 / 0.2D1 * t33) * Lr + (-(0.122D
cc     #3 * t2 + 0.195D3 * t1 - 0.186D3 * x - 0.86D2) * t7 / 0.27D2 - 0.8D
cc     #1 / 0.3D1 * t10 * z2 + (t90 + t68 + 0.60D2 * t1 - t321 + 0.10D2) *
cc     # t27 * t43 / 0.9D1 - 0.4D1 / 0.9D1 * (0.5D1 * t2 - 0.12D2 * t1 + 0
cc     #.21D2 * x - 0.5D1) * t7 * t34 + 0.8D1 / 0.3D1 * t10 * t86 + 0.4D1 
cc     #/ 0.3D1 * t10 * t74) * NF + (0.899D3 * t2 - 0.212D3 * t1 + 0.346D3
cc     # * x - 0.899D3) * t7 / 0.4D1 - 0.9D1 * (t100 - 0.14D2 * t2 - 0.24D
cc     #2 * t1 - 0.9D1 * x - 0.4D1) * t7 * t208 + 0.3D1 / 0.2D1 * (0.154D3
cc     # * t21 - 0.287D3 * t2 + 0.180D3 * t1 - 0.113D3 * x + 0.44D2) * t27
cc     # * t43 - 0.3D1 * (0.77D2 * t2 - 0.83D2 * t1 + t321 - 0.77D2) * t7 
cc     #* t34 - 0.126D3 * t42 * t364 - 0.18D2 * t263 * t43 * t124 + 0.18D2
cc     # * (t21 - t202 - 0.13D2 * t1 - t82 + 0.1D1) * t7 * t72 * t86 - 0.9
cc     #D1 * t262 * t7 * t142 + 0.9D1 * (0.8D1 * t1 - 0.3D1 * t2 - t273 + 
cc     #0.3D1 * t66 + 0.2D1 + 0.3D1 * x) * t7 * t73 * t74 + 0.108D3 * t33 
cc     #* t135
cc      t397 = (t1 - t31 + 0.2D1) * t7
cc      t409 = 0.132D3 * t21
cc      t486 = -(t16 + t121 + 0.2D1) * t7 * z3 / 0.6D1 - t397 * t74 * t34 
cc     #/ 0.24D2 + 0.5D1 / 0.9D1 * t10 * t75 + (0.1570D4 * t2 - 0.249D3 * 
cc     #t1 + 0.294D3 * x - 0.1282D4) * t7 * t34 / 0.108D3 - (t409 - 0.351D
cc     #3 * t2 + 0.117D3 * t1 + t299 + 0.68D2) * t27 * t105 / 0.72D2 + t39
cc     #7 * t135 * t11 / 0.24D2 + (0.68D2 * t21 - 0.87D2 * t2 + 0.63D2 * t
cc     #1 - 0.82D2 * x + 0.68D2) * t27 * t364 / 0.12D2 - 0.4D1 * t10 * z2 
cc     #* t11 - t397 * t34 * z2 / 0.12D2 - (0.31D2 * t1 + 0.34D2 * x - 0.2
cc     #D1) * t7 * t176 / 0.12D2 + (0.47D2 * t1 + 0.50D2 * x - 0.2D1) * t7
cc     # * t11 * t86 / 0.12D2 + t397 * t34 * t86 / 0.12D2 + (t119 + 0.227D
cc     #3 * t2 + t120 - 0.302D3 * x + 0.68D2) * t27 * t238 / 0.36D2 - (0.1
cc     #7774D5 * t2 - 0.3801D4 * t1 + 0.2982D4 * x - 0.14939D5) * t7 / 0.1
cc     #296D4 + (0.65D2 * t1 + 0.62D2 * x + 0.2D1) * t7 * t153 / 0.12D2 + 
cc     #(t409 - 0.387D3 * t2 + 0.99D2 * t1 + 0.70D2 * x + 0.68D2) * t27 * 
cc     #t218 / 0.36D2 - (0.2384D4 * t21 - 0.3041D4 * t2 + 0.333D3 * t1 - 0
cc     #.598D3 * x + 0.1282D4) * t27 * t43 / 0.216D3 - 0.2D1 / 0.9D1 * (0.
cc     #17D2 * t2 - t23 + t102 - 0.17D2) * t7 * t135
cc      t488 = -(0.2295D4 * t2 - 0.1894D4 * t1 + 0.2159D4 * x - 0.2295D4) 
cc     #* t7 * t34 / 0.4D1 + 0.3D1 * (0.110D3 * t2 - 0.116D3 * t1 + 0.127D
cc     #3 * x - 0.110D3) * t7 * t135 - 0.9D1 * (t69 - t202 - 0.19D2 * t21 
cc     #+ 0.10D2 * t66 + 0.2D1 + t82) * t7 * t27 * t208 * t11 - 0.3D1 / 0.
cc     #4D1 * (0.495D3 * t21 - 0.886D3 * t2 + 0.564D3 * t1 - 0.244D3 * x +
cc     # 0.60D2) * t27 * t218 + 0.9D1 / 0.2D1 * (0.59D2 * t1 + 0.11D2 * t6
cc     #6 + 0.31D2 * x - 0.65D2 * t21 + 0.11D2 - 0.25D2 * t2) * t7 * t27 *
cc     # t95 * t86 + 0.3D1 / 0.4D1 * (0.121D3 * t21 - 0.300D3 * t2 + 0.87D
cc     #2 * t1 + 0.398D3 * x - 0.317D3) * t27 * t238 + (0.4054D4 * t21 - 0
cc     #.6427D4 * t2 + 0.5655D4 * t1 - 0.5083D4 * x + 0.2069D4) * t27 * t4
cc     #3 / 0.8D1 + 0.3D1 / 0.2D1 * t184 * t11 * t124 + 0.3D1 / 0.8D1 * (-
cc     #0.827D3 * t2 + 0.699D3 * t1 + 0.374D3 * t21 - 0.389D3 * x + 0.154D
cc     #3) * t7 * t27 * t74 - 0.18D2 * t263 * t7 * t264 + 0.9D1 * t122 * t
cc     #72 * t7 * t269 - 0.9D1 / 0.8D1 * (t273 + t80 - t23 - t31 - 0.1D1) 
cc     #* t7 * t72 * t276 + 0.9D1 / 0.2D1 * (t273 + 0.16D2 * t2 + 0.33D2 *
cc     # t1 + 0.22D2 * x + 0.11D2) * t72 * t7 * t124 * z2 + 0.9D1 / 0.2D1 
cc     #* (0.23D2 * t21 - 0.48D2 * t2 + 0.69D2 * t1 - 0.66D2 * x + 0.23D2)
cc     # * t27 * t85 * z2 - 0.9D1 / 0.2D1 * (-0.20D2 * t1 - t299 + 0.3D1 +
cc     # 0.33D2 * t66 - 0.15D2 * t21 + 0.13D2 * t2) * t7 * t73 * z3 + t390
cc     # * L + t486 * NF
cc      t489 = t187 + t488
cc
cc
cc	gg_n2_reg = t489
cc
cc	end
cc


c====================================================================
c
c		qgreg
c
c====================================================================	

      double precision function qgreg(z,lambda,QQQ,wlo)
      implicit none 
      double precision QQQ,qgreg_NLO_exact
	double precision qg_n1_reg,qg_n2_reg
      double precision z,lambda
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qgreg = 0d0
		case(1)
			qgreg = qgreg_NLO_exact(z,lambda,QQQ)
     #				+ WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg =  WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qgreg =   0d0
		case(1)
			qgreg =   WC0NLO * qg_n1_reg(z) 
		case(2)
			qgreg = WC1NNLO * qg_n1_reg(z)
     #				+ WC0NNLO * qg_n2_reg(z)
		end select

	endif
      end


c=========================================================================	

	double precision function qgreg_NLO_exact(z,lambda,QQQ)
      implicit none 
      double precision z,QQQ,lambda
      double precision qgreg_effective
	double precision L, Lt, Lr,NF
	double precision pi, z2, z3
	common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3
	double complex sum_Aqqgh,sborn_mass
	double precision Cf,Pgq,born_squared,ysp
	double precision term1,term2,sum_Aqqgh_lambda

	Cf= 4d0/3d0
	Pgq = Cf/2d0*(1d0+(1d0-z)**2)/z
	born_squared = abs(sborn_mass(QQQ))**2
	ysp = -(1d0-z)*(1d0-lambda)
	sum_Aqqgh_lambda=abs(sum_Aqqgh(1d0/ysp,QQQ))**2
		
	term1 = born_squared * (Cf/2d0*z 
     $				- Pgq * dlog(z/(1-z)**2)
     $				- Pgq * L) !L=log(muf**2/mH**2)
	term2 = (
     $			sum_Aqqgh_lambda * (1d0+(1d0-z)**2*lambda)/z
     $			- born_squared     * (1d0+(1d0-z)**2)/z 
     $			)
     $			/(1d0-lambda)
	qgreg_NLO_exact =  (term1+term2)
	
		   
      end



c=========================================================================	
	double precision function qg_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x ** 2
      t4 = 0.1D1 / x
      t5 = (t1 - 0.2D1 * x + 0.2D1) * t4
      t12 = log(x)
      t16 = log(0.1D1 - x)
      t19 = -0.2D1 / 0.3D1 * t5 * L - (t1 - 0.6D1 * x + 0.3D1) * t4 / 0.
     #3D1 - 0.2D1 / 0.3D1 * t5 * t12 + 0.4D1 / 0.3D1 * t5 * t16


	qg_n1_reg = t19	
	
	end
	
	
	
	
c=========================================================================	
	double precision function qg_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	double precision Li2,Li3,S12

		
	z4=1.082323234d0
	t1 = x ** 2
      t4 = t1 * x
      t7 = 0.1D1 / x
      t13 = 0.784D3 * t4
      t17 = log(0.1D1 - x)
      t25 = log(x)
      t26 = t25 ** 2
      t33 = Li3(x)
      t50 = 0.2D1 * x
      t52 = (t1 - t50 + 0.2D1) * t7
      t53 = t17 ** 2
      t59 = 0.33D2 * t1
      t61 = (0.4D1 * t4 + 0.222D3 * x + 0.166D3 + t59) * t7
      t62 = Li2(-x)
      t66 = (t1 + t50 + 0.2D1) * t7
      t67 = S12(-x)
      t74 = S12(x)
      t77 = Li3(t1)
      t80 = S12(t1)
      t95 = Li2(x)
      t104 = t52 * NF
      t118 = t52 * t17
      t121 = L ** 2
      t129 = t52 * t53
      t133 = t25 * t17
      t134 = t52 * t133
      t142 = 0.418D3 * x
      t149 = -(-0.144D3 * t1 - 0.221D3 + 0.738D3 * x + 0.292D3 * t4) * t
     #7 * z2 / 0.27D2 - (0.14796D5 * x + 0.3834D4 * t1 + t13 - 0.21295D5
     #) * t7 * t17 / 0.162D3 + (0.226D3 * t4 + 0.1464D4 * x - 0.234D3 * 
     #t1 - 0.837D3) * t7 * t26 / 0.54D2 + (0.339D3 * t1 + 0.302D3 + 0.47
     #4D3 * x) * t7 * t33 / 0.9D1 + (-0.22042D5 + 0.26424D5 * x + 0.2464
     #D4 * t4 + 0.7143D4 * t1) * t7 * t25 / 0.324D3 - (0.142D3 * x + 0.1
     #45D3 * t1 + 0.108D3) * t7 * t26 * t25 / 0.54D2 + 0.367D3 / 0.54D2 
     #* t52 * t53 * t17 - t61 * t62 / 0.27D2 + 0.8D1 * t66 * t67 - (0.26
     #9D3 * t1 + 0.614D3 * x + 0.74D2) * t7 * t74 / 0.9D1 + t66 * t77 / 
     #0.2D1 - 0.2D1 * t66 * t80 + t7 * (-0.2592D4 + 0.111D3 * t1 + 0.288
     #D3 * t4 + 0.2278D4 * x) * t53 / 0.36D2 + (0.2605D4 - 0.711D3 * t1 
     #- 0.876D3 * x + 0.148D3 * t4) * t7 * t95 / 0.54D2 + 0.2D1 / 0.9D1 
     #* (0.46D2 + 0.45D2 * t1 - 0.81D2 * x) * t7 * z3 + (-0.2D1 / 0.9D1 
     #* t104 + (0.91D2 * t1 + 0.92D2 * x - 0.147D3 + 0.36D2 * t4) * t7 /
     # 0.18D2 - 0.2D1 / 0.9D1 * (0.28D2 * t1 + 0.25D2 * x + 0.27D2) * t7
     # * t25 + 0.31D2 / 0.9D1 * t118) * t121 + ((0.29D2 - 0.38D2 * x + 0
     #.19D2 * t1) * t7 * t25 / 0.27D2 + t129 / 0.18D2 + t52 * t26 / 0.9D
     #1 - 0.2D1 / 0.9D1 * t134 - (0.9D1 * t1 - 0.16D2 * x + 0.13D2) * t7
     # * t17 / 0.9D1 + (0.265D3 - t142 + 0.179D3 * t1) * t7 / 0.162D3) *
     # NF
      t152 = (t1 - 0.6D1 * x + 0.3D1) * t7
      t154 = t52 * t25
      t208 = log(x + 0.1D1)
      t209 = t25 * t208
      t227 = (t104 / 0.3D1 - 0.11D2 / 0.2D1 * t52) * Lr + ((0.31D2 - 0.2
     #2D2 * x + 0.29D2 * t1) * t7 / 0.54D2 - t154 / 0.9D1 + 0.4D1 / 0.9D
     #1 * t118) * NF + (-0.19549D5 + 0.10602D5 * x + 0.4293D4 * t1 + t13
     #) * t7 / 0.324D3 + 0.2D1 / 0.9D1 * (0.62D2 + 0.89D2 * t1 + 0.128D3
     # * x) * t7 * z2 + (t59 + 0.1470D4 * x - 0.1080D4 + 0.400D3 * t4) *
     # t7 * t25 / 0.54D2 - (t142 + 0.72D2 * t4 - 0.489D3 + 0.101D3 * t1)
     # * t7 * t17 / 0.9D1 + 0.106D3 / 0.9D1 * t134 - 0.2D1 * t66 * t209 
     #- 0.2D1 / 0.9D1 * (0.46D2 + 0.162D3 * x + 0.81D2 * t1) * t7 * t95 
     #- (0.64D2 * x + 0.54D2 + 0.67D2 * t1) * t7 * t26 / 0.9D1 - 0.31D2 
     #/ 0.3D1 * t129 - 0.2D1 * t66 * t62
      t265 = t208 ** 2
      t282 = ((t152 / 0.6D1 + t154 / 0.3D1 - 0.2D1 / 0.3D1 * t118) * NF 
     #- 0.11D2 / 0.4D1 * t152 - 0.11D2 / 0.2D1 * t154 + 0.11D2 * t118) *
     # Lr + (-0.199423D6 + 0.6148D4 * t4 + 0.176196D6 * x + 0.10743D5 * 
     #t1) * t7 / 0.1944D4 + t227 * L + 0.107D3 / 0.18D2 * t52 * t26 * t1
     #7 - 0.115D3 / 0.9D1 * t52 * t53 * t25 + t52 * t17 * t95 + 0.4D1 * 
     #t66 * t62 * t208 - 0.4D1 * t66 * t25 * t62 - 0.4D1 * t66 * t208 * 
     #t95 - (0.214D3 + 0.446D3 * x + 0.281D3 * t1) * t7 * t25 * t95 / 0.
     #9D1 - t61 * t209 / 0.27D2 - (-0.5935D4 + 0.4956D4 * x + 0.652D3 * 
     #t4 + 0.363D3 * t1) * t7 * t133 / 0.54D2 - 0.3D1 * t66 * t26 * t208
     # + 0.2D1 * t66 * t25 * t265 + 0.4D1 / 0.9D1 * (0.32D2 * t1 + 0.13D
     #2 + 0.35D2 * x) * t7 * z2 * t25 + 0.6D1 * t66 * z2 * t208 - 0.59D2
     # / 0.9D1 * t52 * t17 * z2
      t283 = t149 + t282

	qg_n2_reg = t283
	end


c====================================================================
c
c		qqbreg
c
c====================================================================	

      double precision function qqbreg(z,QQQ,wlo)
      implicit none 
      double precision QQQ,qqbreg_NLO_exact
	double precision qqb_n1_reg,qqb_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqbreg = 0d0
		case(1)
			qqbreg = qqbreg_NLO_exact(z,QQQ)
     #				+ WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg =  WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqbreg =   0d0
		case(1)
			qqbreg =   WC0NLO * qqb_n1_reg(z) 
		case(2)
			qqbreg = WC1NNLO * qqb_n1_reg(z)
     #				+ WC0NNLO * qqb_n2_reg(z)
		end select

	endif
      end

c=========================================================================	

      double precision function qqbreg_NLO_exact(z,QQQ)
      implicit none 
      double precision z
      double precision QQQ
	double complex sum_Aqqgh
	qqbreg_NLO_exact =  32d0/27d0 * (1d0-z)**3 /z
     $			*abs(sum_Aqqgh(z,QQQ))**2

      end


c=========================================================================	
	double precision function qqb_n1_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3
	z4=1.082323234d0
	

	t1 = x - 0.1D1
      t2 = t1 ** 2
      t7 = -0.32D2 / 0.27D2 * t2 * t1 / x
	
	qqb_n1_reg = t7
	
	end
c=========================================================================	
	double precision function qqb_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12
	z4=1.082323234d0
	
	t1 = x ** 2
      t4 = 0.32D2 / 0.27D2 + 0.32D2 / 0.9D1 * t1 + 0.16D2 / 0.27D2 * x
      t5 = Li2(-x)
      t8 = (x + 0.2D1) ** 2
      t9 = 0.1D1 / x
      t10 = t8 * t9
      t11 = log(x)
      t15 = x - 0.1D1
      t20 = L ** 2
      t22 = t1 * x
      t30 = t15 ** 2
      t32 = t30 * t15 * t9
      t33 = log(-t15)
      t67 = t9 * t33
      t70 = Li2(x)
      t73 = t11 ** 2
      t87 = (t1 + 0.2D1 * x + 0.2D1) * t9
      t89 = log(x + 0.1D1)
      t99 = t89 ** 2
      t116 = t33 ** 2
      t120 = t4 * t5 + (-0.4D1 / 0.9D1 * t11 * t10 + 0.8D1 / 0.9D1 * (x 
     #+ 0.3D1) * t15 * t9) * t20 + (0.16D2 / 0.81D2 * (0.4D1 * t22 - 0.3
     #D1 - 0.12D2 * t1 + 0.15D2 * x) * t9 * t11 - 0.32D2 / 0.81D2 * t32 
     #* t33 + 0.8D1 / 0.243D3 * (0.41D2 * t1 - 0.88D2 * x + 0.23D2) * t1
     #5 * t9) * NF + (0.16D2 / 0.27D2 * t32 * NF - 0.88D2 / 0.9D1 * t32)
     # * Lr + (0.2D1 / 0.81D2 * t15 * (0.263D3 * x + 0.459D3) * t9 + 0.1
     #6D2 / 0.9D1 * t10 * z2 - 0.4D1 / 0.81D2 * (-0.141D3 * t1 + 0.64D2 
     #* t22 + 0.24D2 * x + 0.108D3) * t9 * t11 + 0.32D2 / 0.81D2 * t15 *
     # (0.8D1 * t1 - 0.25D2 * x - 0.19D2) * t67 - 0.16D2 / 0.9D1 * t10 *
     # t70 - 0.4D1 / 0.9D1 * t10 * t73) * L + 0.8D1 / 0.81D2 * (0.10D2 *
     # t22 + 0.12D2 - 0.87D2 * t1 + 0.42D2 * x) * t9 * t70 - 0.16D2 / 0.
     #27D2 * t87 * t5 * t89 + 0.8D1 / 0.9D1 * t87 * t11 * t5 + 0.4D1 / 0
     #.9D1 * t87 * t73 * t89 - 0.8D1 / 0.27D2 * t87 * t99 * t11 - 0.8D1 
     #/ 0.3D1 * t10 * t11 * t70 + 0.4D1 / 0.81D2 * t15 * (0.384D3 * t1 -
     # 0.967D3 * x - 0.75D2) * t67 - 0.32D2 / 0.81D2 * t15 * (0.13D2 * t
     #1 - 0.35D2 * x - 0.14D2) * t9 * t116
      t141 = S12(-x)
      t151 = S12(x)
      t156 = Li3(-x)
      t159 = Li3(x)
      t180 = -0.8D1 / 0.27D2 * t87 * z2 * t89 + 0.8D1 / 0.9D1 * t10 * z2
     # * t11 - 0.2D1 / 0.81D2 * (0.135D3 - 0.2111D4 * t1 + 0.1448D4 * x 
     #+ 0.768D3 * t22) * t9 * t11 + 0.16D2 / 0.81D2 * (0.5D1 - 0.102D3 *
     # t1 + 0.75D2 * x + 0.47D2 * t22) * t9 * z2 - 0.16D2 / 0.27D2 * t87
     # * t141 - 0.8D1 / 0.81D2 * (0.27D2 + 0.44D2 * t22 + 0.39D2 * x - 0
     #.81D2 * t1) * t9 * t73 - 0.32D2 / 0.9D1 * t10 * t151 + t4 * t11 * 
     #t89 - 0.8D1 / 0.9D1 * t87 * t156 + 0.32D2 / 0.9D1 * t10 * t159 - 0
     #.4D1 / 0.81D2 * t15 * (0.651D3 * t1 - 0.1661D4 * x + 0.241D3) * t9
     # - 0.4D1 / 0.27D2 * t10 * t73 * t11 - 0.16D2 / 0.27D2 * t87 * z3 +
     # 0.16D2 / 0.81D2 * t15 * (0.37D2 * t1 - 0.101D3 * x - 0.44D2) * t6
     #7 * t11
      t181 = t120 + t180

	qqb_n2_reg = t181
	end

c====================================================================
c
c		qqreg
c
c====================================================================		

      double precision function qqreg(z,wlo)
      implicit none 
	double precision qq_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			qqreg = 0d0
		case(1)
			qqreg = 0d0 
		case(2)
			qqreg =   WC0NNLO * qq_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			qqreg =   0d0
		case(1)
			qqreg =   0d0 
		case(2)
			qqreg =  WC0NNLO * qq_n2_reg(z)
		end select

	endif
      end



	
c=========================================================================	
	double precision function qq_n2_reg(x)
	implicit double precision (t)
	double precision L, Lt, Lr, NF,x
      common /xsection/ L, Lt, Lr, NF
	double precision pi,z2,z3,z4
	common /consts/ pi, z2, z3
	double precision LLz,DD0,DD1,DD2,DD3	
	double precision Li2,Li3,S12

	t2 = (x + 0.2D1) ** 2
      t3 = 0.1D1 / x
      t4 = t2 * t3
      t5 = log(x)
      t9 = x - 0.1D1
      t10 = (x + 0.3D1) * t9
      t14 = L ** 2
      t16 = Li2(x)
      t19 = t5 ** 2
      t22 = x ** 2
      t23 = 0.5D1 * t22
      t29 = log(-t9)
      t30 = t3 * t29
      t37 = (0.5D1 * x + 0.17D2) * t9
      t48 = 0.4D1 * x
      t57 = Li3(x)
      t60 = S12(x)
      t68 = (t22 - 0.2D1 * x + 0.2D1) * t3
      t90 = t29 ** 2
      t108 = (-0.4D1 / 0.9D1 * t4 * t5 + 0.8D1 / 0.9D1 * t10 * t3) * t14
     # + (-0.16D2 / 0.9D1 * t4 * t16 - 0.4D1 / 0.9D1 * t4 * t19 + 0.4D1 
     #/ 0.9D1 * (-0.12D2 + t23 + 0.8D1 * x) * t3 * t5 - 0.32D2 / 0.9D1 *
     # t10 * t30 + 0.16D2 / 0.9D1 * t4 * z2 + 0.2D1 / 0.3D1 * t37 * t3) 
     #* L - 0.16D2 / 0.27D2 * (0.17D2 * x + t23 + 0.19D2) * t3 * t5 * t1
     #6 - 0.8D1 / 0.9D1 * (t48 + t22 - 0.6D1) * t3 * t16 + 0.8D1 / 0.27D
     #2 * (0.46D2 * x + 0.50D2 + 0.13D2 * t22) * t3 * t57 - 0.32D2 / 0.9
     #D1 * t4 * t60 - 0.4D1 / 0.27D2 * t4 * t19 * t5 - 0.4D1 / 0.27D2 * 
     #t68 * t19 * t29 + 0.4D1 / 0.27D2 * (0.26D2 * x - 0.18D2 + 0.9D1 * 
     #t22) * t3 * t19 - 0.16D2 / 0.3D1 * t10 * t30 * t5 + 0.8D1 / 0.9D1 
     #* t4 * z2 * t5 + 0.2D1 / 0.27D2 * (0.124D3 * x + 0.69D2 * t22 - 0.
     #177D3) * t3 * t5 + 0.32D2 / 0.9D1 * t10 * t3 * t90 - 0.4D1 / 0.3D1
     # * t37 * t30 - 0.8D1 / 0.9D1 * (-0.6D1 + 0.3D1 * t22 + t48) * t3 *
     # z2 - 0.8D1 / 0.27D2 * t68 * z3 + 0.4D1 / 0.27D2 * (0.27D2 * x + 0
     #.160D3) * t9 * t3
	qq_n2_reg = t108
	end

c====================================================================
c
c		q1q2reg
c
c====================================================================	

      double precision function q1q2reg(z,wlo)
      implicit none 
	double precision q1q2_n2_reg
      double precision z
      integer wlo
          double precision WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO
          double precision WC2NNLO
          common /WC/  WC0LO,WC0NLO,WC0NNLO,WC1NLO,WC1NNLO,WC2NNLO
c ------- 
	!: effective theory flag to switch between HQET LO/NLO and exact LO/NLO
	integer effective_theory_flag
	common /common_eff_theory_flag/ effective_theory_flag
c -------
	
	if (effective_theory_flag.eq.0) then 
		select case (wlo)
		case(0)
			q1q2reg = 0d0
		case(1)
			q1q2reg =  0d0 
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select
	elseif (effective_theory_flag.eq.1) then
		select case (wlo)
		case(0)
			q1q2reg =   0d0
		case(1)
			q1q2reg =   0d0
		case(2)
			q1q2reg = WC0NNLO * q1q2_n2_reg(z)
		end select

	endif
      end


c=========================================================================	
      doubleprecision function q1q2_n2_reg(x)
	implicit double precision (t)
      double precision pi, z2, z3, L, Lt, Lr,x
      double precision Li2, Li3, S12, NF
      double precision s1,s2,s3,s4,s5,s6,s7,s8,s9,s10
      external Li2, Li3, S12
      common /xsection/ L, Lt, Lr, NF 
      common /consts/ pi, z2, z3       
      q1q2_n2_reg=((-4.D0/9.D0*(x+2)**2/x*dlog(x)
     #+8.D0/9.D0*(x+3)*(x-1)/x)
     #     *L**2
     #+(-16.D0/9.D0*(x+2)**2/x*Li2(x)-4.D0/9.D0*(x+2)**2/x*dlog(x)**2+4.
     #D0/9.D0*(-12+5*x**2+8*x)/x*dlog(x)-32.D0/9.D0*(x+3)*(x-1)/x*dlog(-
     #x+1)+16.D0/9.D0*(x+2)**2/x*z2+2.D0/3.D0*(5*x+17)*(x-1)/x)*L-8.D0/3
     #.D0*(x+2)**2/x*dlog(x)*Li2(x)-8.D0/9.D0*(4*x+x**2-6)/x*Li2(x)+32.D
     #0/9.D0*(x+2)**2/x*Li3(x)-32.D0/9.D0*(x+2)**2/x*S12(x)-4.D0/27.D0*(
     #x+2)**2/x*dlog(x)**3+8.D0/9.D0*(4*x-3+x**2)/x*dlog(x)**2-16.D0/3.D
     #0*(x+3)*(x-1)/x*dlog(-x+1)*dlog(x)+8.D0/9.D0*(x+2)**2/x*z2*dlog(x)
     #+2.D0/9.D0*(44*x-59+29*x**2)/x*dlog(x)+32.D0/9.D0*(x+3)*(x-1)/x*dl
     #og(-x+1)**2-4.D0/3.D0*(5*x+17)*(x-1)/x*dlog(-x+1)-8.D0/9.D0*(-6+3*
     #x**2+4*x)/x*z2+2.D0/9.D0*(11*x+105)*(x-1)/x)!*alphas**2
        return
      end	

c====================================================================
c====================================================================
c	
c			auxiliary functions 
c
c====================================================================
c====================================================================
C     returns Sum_q born_ampl(tau_q)  
      double complex function sborn_mass(QQQ)
      implicit none
      integer i
      double precision QQQ

      integer number_of_quarks
      double complex res,brn_q_ep0,xxx
      !double precision ZZq
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	
      
cc      xxx=dcmplx(0d0,0d0)
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
cc        print*,i,res,1d0-abs(xxx)**2/abs(res)**2
cc        xxx=res
      enddo  
    
      sborn_mass = res
      end 

c====================================================================

C     returns Sum_q born_ampl(tau_q)  where the sum runs over HEAVY QUARKS
c	HEAVY is defined to be larger than the heavy_quark_threshold below
      double complex function born_sum_heavy(QQQ)
      implicit none
      integer i
      double precision QQQ

      integer number_of_quarks
      double complex res,brn_q_ep0,xxx
      !double precision ZZq
	
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
      
      double precision heavy_quark_threshold
	
	heavy_quark_threshold=50d0
cc      xxx=dcmplx(0d0,0d0)
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        if (abs(Mq_square_complex(i)).gt.heavy_quark_threshold) then 
		!print*,"quark ",i," is heavy "
		res = res + Yq(i)*brn_q_ep0(Xq(i))*Wq(i)**2/64d0*(-3d0/4d0)
	  endif
cc        print*,i,res,1d0-abs(xxx)**2/abs(res)**2
cc        xxx=res
      enddo  
    
      born_sum_heavy = res
      end  
c====================================================================

C     returns born of Passarino, Actis, Sturm, Ucciratti 	
c	http://arxiv.org/abs/arXiv:0809.1301
c	We use their deltaEWK interpolated from their grid, and we 
c	need the born with top only, and with the values of top 
c	used there. This function is only used in 
c	calculate_wilson_coefficients @ higgs.F
      double complex function born_pass(QQQ)
      implicit none
      double precision QQQ,mtop_pass
	double complex brn_q_ep0,Wq,Xq
	
	mtop_pass = 170.9d0
	Wq = dcmplx(4d0*mtop_pass**2/QQQ**2,0d0)
	Xq = -Wq/(sqrt(1d0-Wq)+1d0)**2
	
	born_pass = brn_q_ep0(Xq)*Wq**2/64d0*(-3d0/4d0)
	!print*, born_pass
      end  


c====================================================================


C     returns Sum_q virtual_ampl(tau_q)  
      double complex function svirtual_mass(QQQ)
      implicit none
      integer i
      double precision QQQ
      
      double complex res,twol_q_fin,twol_q_fin_bon
      double precision myrealpart
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	

      integer number_of_quarks

      
      !: note that we use here twol_q_fin_bon instead of twol_q_fin
	!: the difference is described in massive_ampls.F
	!: twol_q_fin_bon is known to have numerical (cancelation) issues for
	!: very heavy (mq>8TeV) quarks

      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks

		if (myrealpart(Xq(i)).gt.0.9999) then 
			print*,"[svirtual_mass]: warning, x_q is too large(",
     #							xq,") for quark ",i
		endif
        res = res + Yq(i)*twol_q_fin_bon(Xq(i))
      enddo  
    
      svirtual_mass = res
      end  

c====================================================================

C     returns Sum_q Aqqgh(tau_q)  necessary for reg_qqbar
      double complex function sum_Aqqgh(z,QQQ)
      implicit none
      integer i
      double precision QQQ,z
      integer number_of_quarks
      double complex res,twol_q_fin,mq
      !double precision ZZq
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
	
      double complex Aqqgh
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
	  mq = sqrt(Mq_square_complex(i))
        res = res + Yq(i)*Aqqgh(z,QQQ,Wq(i),mq)
     #      *Wq(i)*(3d0/4d0)
      enddo  
    
      sum_Aqqgh = res
      end  


c====================================================================
C     returns Sum_q Yq * m_q^2 Aq1(tau,z,lambda)  
      double complex function sum_over_quarks(func,z,lambda,QQQ)
      implicit none
      integer i
      double precision QQQ,z,lambda
      
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks
      
	integer number_of_quarks
      double complex res,func,mq
      !double precision ZZq
      
      
      res = dcmplx(0d0,0d0)    
      do i=1,number_of_quarks
        mq  = sqrt(Mq_square_complex(i)) 
	  res = res + Yq(i)* 
     #      func(z,lambda,mq,QQQ)*
     #      Wq(i)
     #      *3d0/32d0/QQQ**2
      enddo  
    
      sum_over_quarks = res
      end


c==========================================================================
c
c           TESTING SUBROUTINES BELOW - REMOVE BY FINAL RELEASE
c
c--------------------------------------------------------------------------





c     test_limits compares the 1/2* z^4 * Sum_q{ | real_ggg_ampl1 |^2 } 
c     with (1-z+z^2) * born_ampl() 
c     at z=0.3, lambda=1e-10

      subroutine test_limits(QQQ)
      implicit none
      double precision QQQ
      double complex test_limit,test_mq,tau_q,test_born,triaf
      double complex sum_q_A1,sum_q_A2a,sborn_mass
      double complex sum_q_A2b,sum_q_A2c,sum_over_quarks  
      double precision z,lambda,tmp 
      external Aq1,Aq2a,Aq2b,Aq2c 


      


    ! testing whether the lambda->0 are still ok
      print*,"--------   limit testing \n"
      z=0.3d0
      lambda=1.d-10
      
      
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit
      
    ! testing whether the lambda ->1 are still ok
      print*,"--------   limit testing \n"
      z=0.03d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit      
      ! testing whether the lambda ->1 are still ok
      print*,"-------- z->1  limit testing \n"
      z=0.99999d0
      lambda=1-1d-10
       
      sum_q_A1=sum_over_quarks(Aq1,z,lambda,QQQ) 
      sum_q_A2a=sum_over_quarks(Aq2a,z,lambda,QQQ) 
      sum_q_A2b=sum_over_quarks(Aq2b,z,lambda,QQQ) 
      sum_q_A2c=sum_over_quarks(Aq2c,z,lambda,QQQ) 
      tmp = abs(sum_q_A1)**2 + 
     #         abs(sum_q_A2a)**2 +
     #         abs(sum_q_A2b)**2 +
     #         abs(sum_q_A2c)**2

c      test_mq=  dcmplx(172.7d0,0d0)
c      tau_q = 4d0* test_mq**2/QQQ**2
      
c      test_born = 3d0/2d0*tau_q*(
c     #             1d0-0.5d0*(1d0-tau_q)*triaf(test_mq,QQQ**2)
c     #                          ) 
      test_born = sborn_mass(QQQ)  
      test_limit = (1d0-z+z**2)**2*abs(test_born)**2
      print*,"test 1 \t z=",z,"\tlambda=",lambda
      print*,"Real(L=1d-6)=",tmp*z**4/2d0
      print*,"limit       =",test_limit  
c     print*,"QQQ=",QQQ,z,test_limit   
      stop
      
      end        
      
      
    
      subroutine virtual_11_over_2_test()
      implicit none
      double complex twol_q_fin,tau_q,xq,brn_q_ep0,born,two_loop_fin
	double complex twol_q_fin_bon,bonciani
      integer i
      tau_q = dcmplx(0.5d0,0d0)
      
      do i=1,20
		tau_q = 0.5d0 + (i-1.0)*100d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born
c		print*,!"mt=",dble(sqrt(tau_q*120d0**2)/2d0),
c     #	" tau=",tau_q,
      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
	do i=1,20
		tau_q = tau_q*10d0
		xq =  -tau_q/(sqrt(1d0-tau_q)+1d0)**2
		two_loop_fin = twol_q_fin(-xq)/64d0/8d0!*(3d0/4d0)
		born = brn_q_ep0(xq)*tau_q**2/64d0*(-3d0/4d0)
		bonciani = twol_q_fin_bon(xq)*(-2d0/3d0)
		!print*,"***"
		!print*,"tau=",tau_q," x=",xq
		!print*,"born =",born
c		print*,"tau=",tau_q,"\t2loop=",two_loop_fin
		!print*,"11*4/3*born=",11d0*4d0/3d0*born

      	print*,"tau=",tau_q,"\tbonciani=",bonciani,11d0/2d0*born
      
      enddo
      end

      
