C-------- driver
      subroutine test_hard(QQQ)
      implicit none
      
      integer ndim, ncomp, verbose, last, seed, mineval, maxeval
	  double precision epsrel, epsabs, userdata
      parameter (ndim = 1)
	  parameter (ncomp = 1)
	  parameter (userdata = 0)
	  parameter (epsrel = 1D-4)
	  parameter (epsabs = 1D-12)
	  parameter (verbose = 2)
	  parameter (last = 4)
	  parameter (seed = 0)
	  parameter (mineval = 0)
	  parameter (maxeval = 50000000)

	  integer nstart, nincrease, nbatch, gridno
	  character*(*) statefile	
	  parameter (nstart = 5000)
	  parameter (nincrease =0)
	  parameter (nbatch = 1000)
	  parameter (gridno = 0)
	  parameter (statefile = "")
      integer i
      double precision integral(ncomp), error(ncomp), prob(ncomp)
      integer  neval, fail
      
      external my_lambda_integral
      double precision QQQ,QQQm
      common /passingQQQ/ QQQm
      
      double complex Aq1,real_gg_1,mq,Aq2a,real_gg_2
      double complex Aq2b,real_gg_3,Aq2c,real_gg_4
      double precision z,lambda,limit_1,limit_2,limit_3,limit_4
      
      z=0.006d0
      lambda=0.234d0
      lambda=1d0-1e-4
      mq=dcmplx(0d0,0d0)
      do i=1,40
      mq=mq+100d0

      real_gg_1 = Aq1(z,lambda,mq,QQQ)*
     #      4d0*mq**2/QQQ**2
     #      *3d0/32d0/QQQ**2 
      limit_1 = 1d0/2d0*(-2 * (1 - lambda + lambda ** 2 - z 
     #+ 2 * z * lambda - 2 * z *
     # lambda ** 2 + z ** 2 - z ** 2 * lambda + z ** 2 * lambda ** 2) / 
     #z ** 2)

      print*,"R1 ", real_gg_1,z,lambda,mq,limit_1
      
      real_gg_2 = Aq2a(z,lambda,mq,QQQ)*
     #      4d0*mq**2/QQQ**2
     #      *3d0/32d0/QQQ**2 
      limit_2 = (1d0-z)/z
      print*,"R2 ", real_gg_2,z,lambda,mq,limit_2
c      enddo

      real_gg_3 = Aq2b(z,lambda,mq,QQQ)*
     #      4d0*mq**2/QQQ**2
     #      *3d0/32d0/QQQ**2 
      limit_3 = (1d0-z)/z**2
      print*,"R3 ", real_gg_3,z,lambda,mq,limit_3
      
c      enddo

      real_gg_4 = Aq2c(z,lambda,mq,QQQ)*
     #      4d0*mq**2/QQQ**2
     #      *3d0/32d0/QQQ**2 
      limit_4 = -1d0/z
      print*,"R4 ", real_gg_4,z,lambda,mq,limit_4
      enddo

      print*,"..",QQQ**2/z,4d0*mq**2, 4d0*mq**2/ (QQQ**2/z)
      stop
            
      QQQm=QQQ                  
      print*,"---------------- start --------------"

      call vegas(ndim, ncomp, my_lambda_integral, userdata,
     #    epsrel, epsabs, verbose, seed,
     #    mineval, maxeval, nstart, nincrease, nbatch,
     #    gridno, statefile,
     #    neval, fail, integral, error, prob)    

      print*,"---------------- end --------------"
      print*,''
      stop
      end 
      

      integer function my_lambda_integral(ndim,vars,ncomp,risc)
      implicit none
      INTEGER ndim,ncomp
      double precision vars(ndim), risc(ncomp)
      double precision hard_ampl,hard,born_squared,lambda_limit
      double precision z,lambda,alphas
      double complex real_ggg_ampl1,real_ggg_ampl2,real_ggg_ampl3
      double complex real_ggg_ampl4,sborn_mass,sum_over_quarks 
      external Aq1,Aq2a,Aq2b,Aq2c
      double precision QQQm
      common /passingQQQ/ QQQm
      !
	double precision double_mq(100),Yq(100)
	double complex Wq(100),Xq(100),Mq_square_complex(100)
	common /XWq/ Xq,Wq,Mq_square_complex,double_mq,Yq,
     # number_of_quarks 
	integer   number_of_quarks
      !
      double precision s,t,u
      double complex triaf      
      z=0.5d0
      alphas = 0.117d0/3.1415d0
      lambda = vars(1)
      real_ggg_ampl1 =sum_over_quarks(Aq1,z,lambda,QQQm) 
      real_ggg_ampl2 =sum_over_quarks(Aq2a,z,lambda,QQQm)
      real_ggg_ampl3 =sum_over_quarks(Aq2b,z,lambda,QQQm)
      real_ggg_ampl4 =sum_over_quarks(Aq2c,z,lambda,QQQm)   
      hard_ampl = abs(real_ggg_ampl1)**2  
     #         +abs(real_ggg_ampl2)**2 
     #         +abs(real_ggg_ampl3)**2 
     #         +abs(real_ggg_ampl4)**2
        
      born_squared = abs(sborn_mass(QQQm))**2  
      lambda_limit = (1d0-z+z**2)**2   *   born_squared
      
      hard =  3d0 *(1d0/2d0*z**4 * hard_ampl - lambda_limit ) 
     #              /z/(1d0-z)/lambda/(1d0-lambda)
c      print*,1d0/2d0*z**4 * hard_ampl , lambda_limit,hard,lambda  

c   limits of integrals
c      s = QQQm**2 / z
c      t = -s*(1d0-z)*lambda
c      u = -s*(1d0-z)*(1d0-lambda)  
c      Mqu  = sqrt(Mq_square_complex(1))
      
c      risc(1) = hard!/abs(Mq_square_complex(1))**2d0
c      risc(1)=1d0/2d0*z**4 * hard_ampl
c      print*,"* * * * * * * "
c      print*,Box_Intv2(t,u,s,Mqu,s+t+u)
c      print*,Box_Intv2(t,u,s,Mqu,t) 
c      print*,Box_Intv2(t,u,s,Mqu,u)
c      print*,boxf(Mqu,t,u,s),t,u,s
c       risc(1)=Box_Intv2(t,u,s,Mqu,t) 
c      stop
      risc(1)=hard
c      print*,lambda,1d0/2d0*z**4 * hard_ampl,lambda_limit
      my_lambda_integral = 0
      end


